# coding: utf-8

# flake8: noqa
"""
    Acre Platform User API

    # CORS CORS is implemented by all Acre API endpoints and only certain hostnames are allowed for each deployment of the API. If your use case requires calling the Acre User API from a browser, please contact Acre to arrange the appropriate configuration. # API Authentication The primary method of authentication for users of the Acre API is with the use of JSON Web Tokens (JWTs), which are suplemented by an application specific API Key. The API key must be provided through the `X-API-KEY` HTTP header and will be provided by your Acre Customer Success Manager. The JWT must be provided through a cookie with key of `authorization`. The JWT must be generated and signed as per the following section. # Generating JWTs JWT must either be generated by a third-party such as Azure ADB2C that has been configured for the appropriate service and/or user account, or alternatively can be generated locally and signed by an private key for which the public key has been made available to Acre via a JWKS URL. In addition to being signed by your private key, the JWT will also need to contain at a minimum:  * An issuer `iss`, which must be a valid URI previously agreed with Acre.  * A subject `sub`, which must be a unique identifier for the user and/or service account previously agreed with Acre.  * An expiry time `exp` which must not be more than four hours in the future.  * A not before time `nbf` which must be in the past, but not greater than six hours in the past.  The JWT should be signed using RS256.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


# import models into model package
from acre_api.models.acre_processor_add_case_protection_product_body import AcreProcessorAddCaseProtectionProductBody
from acre_api.models.acre_processor_add_general_insurance_product_case_body import AcreProcessorAddGeneralInsuranceProductCaseBody
from acre_api.models.acre_processor_create_client_organisation_relationship_body import AcreProcessorCreateClientOrganisationRelationshipBody
from acre_api.models.acre_processor_update_case_status_body import AcreProcessorUpdateCaseStatusBody
from acre_api.models.additional_loan_purpose import AdditionalLoanPurpose
from acre_api.models.arrear_creditor_type import ArrearCreditorType
from acre_api.models.authentication_provider_authentication_mechanism import AuthenticationProviderAuthenticationMechanism
from acre_api.models.case_details_cancellation_reason import CaseDetailsCancellationReason
from acre_api.models.case_details_client_id_and_version import CaseDetailsClientIDAndVersion
from acre_api.models.case_details_conveyancer import CaseDetailsConveyancer
from acre_api.models.case_details_conveyancing_status_type import CaseDetailsConveyancingStatusType
from acre_api.models.case_details_conveyancing_type import CaseDetailsConveyancingType
from acre_api.models.case_details_conveyancing_update import CaseDetailsConveyancingUpdate
from acre_api.models.case_details_conveyancing_update_message_type import CaseDetailsConveyancingUpdateMessageType
from acre_api.models.case_details_conveyancing_update_property import CaseDetailsConveyancingUpdateProperty
from acre_api.models.case_details_conveyancing_update_source import CaseDetailsConveyancingUpdateSource
from acre_api.models.case_details_enbs_event import CaseDetailsENBSEvent
from acre_api.models.case_details_eidv_result_override import CaseDetailsEidvResultOverride
from acre_api.models.case_details_lead_metadata import CaseDetailsLeadMetadata
from acre_api.models.case_details_mortgage_reason import CaseDetailsMortgageReason
from acre_api.models.case_protection_length_of_time import CaseProtectionLengthOfTime
from acre_api.models.cdm_add_case_document_response import CdmAddCaseDocumentResponse
from acre_api.models.cdm_add_case_protection_product_response import CdmAddCaseProtectionProductResponse
from acre_api.models.cdm_add_general_insurance_product_case_response import CdmAddGeneralInsuranceProductCaseResponse
from acre_api.models.cdm_add_mortgage_case_response import CdmAddMortgageCaseResponse
from acre_api.models.cdm_add_mortgage_product_response import CdmAddMortgageProductResponse
from acre_api.models.cdm_additional_eidv_information import CdmAdditionalEidvInformation
from acre_api.models.cdm_additional_loan import CdmAdditionalLoan
from acre_api.models.cdm_additional_supplementary_information import CdmAdditionalSupplementaryInformation
from acre_api.models.cdm_addn_metadata import CdmAddnMetadata
from acre_api.models.cdm_address import CdmAddress
from acre_api.models.cdm_affordability import CdmAffordability
from acre_api.models.cdm_affordability_lenders import CdmAffordabilityLenders
from acre_api.models.cdm_answer import CdmAnswer
from acre_api.models.cdm_appointed_representative_monitoring import CdmAppointedRepresentativeMonitoring
from acre_api.models.cdm_area_for_improvement import CdmAreaForImprovement
from acre_api.models.cdm_arrears_summary import CdmArrearsSummary
from acre_api.models.cdm_asu import CdmAsu
from acre_api.models.cdm_authentication_provider import CdmAuthenticationProvider
from acre_api.models.cdm_auto_satisfy import CdmAutoSatisfy
from acre_api.models.cdm_availability import CdmAvailability
from acre_api.models.cdm_board_panel import CdmBoardPanel
from acre_api.models.cdm_bulk_assign_case import CdmBulkAssignCase
from acre_api.models.cdm_bulk_assign_case_request import CdmBulkAssignCaseRequest
from acre_api.models.cdm_bulk_assign_case_response import CdmBulkAssignCaseResponse
from acre_api.models.cdm_bulk_create_lead_case import CdmBulkCreateLeadCase
from acre_api.models.cdm_bulk_create_lead_cases_request import CdmBulkCreateLeadCasesRequest
from acre_api.models.cdm_bulk_create_lead_cases_response import CdmBulkCreateLeadCasesResponse
from acre_api.models.cdm_case import CdmCase
from acre_api.models.cdm_case_calculated_values import CdmCaseCalculatedValues
from acre_api.models.cdm_case_details import CdmCaseDetails
from acre_api.models.cdm_case_details_flag import CdmCaseDetailsFlag
from acre_api.models.cdm_case_details_flag_review import CdmCaseDetailsFlagReview
from acre_api.models.cdm_case_details_flag_type import CdmCaseDetailsFlagType
from acre_api.models.cdm_case_details_note import CdmCaseDetailsNote
from acre_api.models.cdm_case_details_note_assignee_type import CdmCaseDetailsNoteAssigneeType
from acre_api.models.cdm_case_details_note_note_status import CdmCaseDetailsNoteNoteStatus
from acre_api.models.cdm_case_details_note_note_type import CdmCaseDetailsNoteNoteType
from acre_api.models.cdm_case_details_product_type import CdmCaseDetailsProductType
from acre_api.models.cdm_case_details_status import CdmCaseDetailsStatus
from acre_api.models.cdm_case_protection import CdmCaseProtection
from acre_api.models.cdm_case_status_update_type import CdmCaseStatusUpdateType
from acre_api.models.cdm_client import CdmClient
from acre_api.models.cdm_client_account import CdmClientAccount
from acre_api.models.cdm_client_account_type import CdmClientAccountType
from acre_api.models.cdm_client_address import CdmClientAddress
from acre_api.models.cdm_client_calculated_values import CdmClientCalculatedValues
from acre_api.models.cdm_client_dependant import CdmClientDependant
from acre_api.models.cdm_client_dependant_relationship_type import CdmClientDependantRelationshipType
from acre_api.models.cdm_client_deposit import CdmClientDeposit
from acre_api.models.cdm_client_deposit_type import CdmClientDepositType
from acre_api.models.cdm_client_details import CdmClientDetails
from acre_api.models.cdm_client_details_default_event import CdmClientDetailsDefaultEvent
from acre_api.models.cdm_client_details_employment_status import CdmClientDetailsEmploymentStatus
from acre_api.models.cdm_client_employment_income import CdmClientEmploymentIncome
from acre_api.models.cdm_client_employment_income_employment_basis import CdmClientEmploymentIncomeEmploymentBasis
from acre_api.models.cdm_client_income import CdmClientIncome
from acre_api.models.cdm_client_income_detail import CdmClientIncomeDetail
from acre_api.models.cdm_client_organisation_relationship import CdmClientOrganisationRelationship
from acre_api.models.cdm_client_outstanding_debt import CdmClientOutstandingDebt
from acre_api.models.cdm_client_outstanding_debt_default_event import CdmClientOutstandingDebtDefaultEvent
from acre_api.models.cdm_client_pension_income import CdmClientPensionIncome
from acre_api.models.cdm_client_relationship import CdmClientRelationship
from acre_api.models.cdm_client_relationship_relationship_type import CdmClientRelationshipRelationshipType
from acre_api.models.cdm_client_self_employment_income import CdmClientSelfEmploymentIncome
from acre_api.models.cdm_client_verification_metadata import CdmClientVerificationMetadata
from acre_api.models.cdm_commission_details import CdmCommissionDetails
from acre_api.models.cdm_commission_paid_on_condition import CdmCommissionPaidOnCondition
from acre_api.models.cdm_commission_structure import CdmCommissionStructure
from acre_api.models.cdm_commission_structure_status import CdmCommissionStructureStatus
from acre_api.models.cdm_commission_type import CdmCommissionType
from acre_api.models.cdm_company_class import CdmCompanyClass
from acre_api.models.cdm_compliance_process_config import CdmComplianceProcessConfig
from acre_api.models.cdm_conditional_on_introducer import CdmConditionalOnIntroducer
from acre_api.models.cdm_conditional_on_related_user import CdmConditionalOnRelatedUser
from acre_api.models.cdm_contact_history import CdmContactHistory
from acre_api.models.cdm_cover_units import CdmCoverUnits
from acre_api.models.cdm_create_acre_mortgage_product_request import CdmCreateAcreMortgageProductRequest
from acre_api.models.cdm_create_acre_mortgage_product_response import CdmCreateAcreMortgageProductResponse
from acre_api.models.cdm_create_authentication_provider_response import CdmCreateAuthenticationProviderResponse
from acre_api.models.cdm_create_case_flag_response import CdmCreateCaseFlagResponse
from acre_api.models.cdm_create_case_flag_review_response import CdmCreateCaseFlagReviewResponse
from acre_api.models.cdm_create_case_referral_request import CdmCreateCaseReferralRequest
from acre_api.models.cdm_create_case_request import CdmCreateCaseRequest
from acre_api.models.cdm_create_case_response import CdmCreateCaseResponse
from acre_api.models.cdm_create_case_version_response import CdmCreateCaseVersionResponse
from acre_api.models.cdm_create_client_organisation_relationship_response import CdmCreateClientOrganisationRelationshipResponse
from acre_api.models.cdm_create_client_request import CdmCreateClientRequest
from acre_api.models.cdm_create_client_response import CdmCreateClientResponse
from acre_api.models.cdm_create_client_version_response import CdmCreateClientVersionResponse
from acre_api.models.cdm_create_commission_structure_response import CdmCreateCommissionStructureResponse
from acre_api.models.cdm_create_document_requirement_request import CdmCreateDocumentRequirementRequest
from acre_api.models.cdm_create_document_requirement_response import CdmCreateDocumentRequirementResponse
from acre_api.models.cdm_create_document_verification_response import CdmCreateDocumentVerificationResponse
from acre_api.models.cdm_create_general_insurance_product_request import CdmCreateGeneralInsuranceProductRequest
from acre_api.models.cdm_create_general_insurance_product_response import CdmCreateGeneralInsuranceProductResponse
from acre_api.models.cdm_create_group_response import CdmCreateGroupResponse
from acre_api.models.cdm_create_mortgage_response import CdmCreateMortgageResponse
from acre_api.models.cdm_create_mortgage_version_response import CdmCreateMortgageVersionResponse
from acre_api.models.cdm_create_mortgage_with_product_request import CdmCreateMortgageWithProductRequest
from acre_api.models.cdm_create_mortgage_with_product_response import CdmCreateMortgageWithProductResponse
from acre_api.models.cdm_create_note_response import CdmCreateNoteResponse
from acre_api.models.cdm_create_organisation_response import CdmCreateOrganisationResponse
from acre_api.models.cdm_create_permission_assignment_response import CdmCreatePermissionAssignmentResponse
from acre_api.models.cdm_create_permission_assignments_request import CdmCreatePermissionAssignmentsRequest
from acre_api.models.cdm_create_permission_assignments_response import CdmCreatePermissionAssignmentsResponse
from acre_api.models.cdm_create_property_request import CdmCreatePropertyRequest
from acre_api.models.cdm_create_property_response import CdmCreatePropertyResponse
from acre_api.models.cdm_create_property_version_response import CdmCreatePropertyVersionResponse
from acre_api.models.cdm_create_protection_product_request import CdmCreateProtectionProductRequest
from acre_api.models.cdm_create_protection_product_response import CdmCreateProtectionProductResponse
from acre_api.models.cdm_create_protection_product_version_response import CdmCreateProtectionProductVersionResponse
from acre_api.models.cdm_create_role_response import CdmCreateRoleResponse
from acre_api.models.cdm_create_template_response import CdmCreateTemplateResponse
from acre_api.models.cdm_create_user_response import CdmCreateUserResponse
from acre_api.models.cdm_credentials import CdmCredentials
from acre_api.models.cdm_credit_report_retrievals import CdmCreditReportRetrievals
from acre_api.models.cdm_credit_search_consent import CdmCreditSearchConsent
from acre_api.models.cdm_credit_search_consent_type import CdmCreditSearchConsentType
from acre_api.models.cdm_day import CdmDay
from acre_api.models.cdm_deduction_type import CdmDeductionType
from acre_api.models.cdm_delete_authentication_provider import CdmDeleteAuthenticationProvider
from acre_api.models.cdm_delete_authentication_provider_response import CdmDeleteAuthenticationProviderResponse
from acre_api.models.cdm_delete_case_document_response import CdmDeleteCaseDocumentResponse
from acre_api.models.cdm_delete_case_protection_product_response import CdmDeleteCaseProtectionProductResponse
from acre_api.models.cdm_delete_client_data_response import CdmDeleteClientDataResponse
from acre_api.models.cdm_delete_client_health_data_response import CdmDeleteClientHealthDataResponse
from acre_api.models.cdm_delete_document_response import CdmDeleteDocumentResponse
from acre_api.models.cdm_delete_general_insurance_product_case_response import CdmDeleteGeneralInsuranceProductCaseResponse
from acre_api.models.cdm_delete_mortgage_case_response import CdmDeleteMortgageCaseResponse
from acre_api.models.cdm_delete_mortgage_product_response import CdmDeleteMortgageProductResponse
from acre_api.models.cdm_delete_reason import CdmDeleteReason
from acre_api.models.cdm_describe_case_verification_response import CdmDescribeCaseVerificationResponse
from acre_api.models.cdm_document import CdmDocument
from acre_api.models.cdm_document_metadata import CdmDocumentMetadata
from acre_api.models.cdm_document_request import CdmDocumentRequest
from acre_api.models.cdm_document_requirement import CdmDocumentRequirement
from acre_api.models.cdm_document_verification import CdmDocumentVerification
from acre_api.models.cdm_eidv import CdmEIDV
from acre_api.models.cdm_enbs_message import CdmENBSMessage
from acre_api.models.cdm_early_repayment_charge_periods import CdmEarlyRepaymentChargePeriods
from acre_api.models.cdm_editor import CdmEditor
from acre_api.models.cdm_email_template_request import CdmEmailTemplateRequest
from acre_api.models.cdm_email_template_response import CdmEmailTemplateResponse
from acre_api.models.cdm_employment_basis import CdmEmploymentBasis
from acre_api.models.cdm_enforcement_level import CdmEnforcementLevel
from acre_api.models.cdm_entity import CdmEntity
from acre_api.models.cdm_entity_type import CdmEntityType
from acre_api.models.cdm_equity_release_lifetime import CdmEquityReleaseLifetime
from acre_api.models.cdm_export_type import CdmExportType
from acre_api.models.cdm_extended_device_details import CdmExtendedDeviceDetails
from acre_api.models.cdm_external import CdmExternal
from acre_api.models.cdm_external_id import CdmExternalID
from acre_api.models.cdm_fee import CdmFee
from acre_api.models.cdm_fee_configuration import CdmFeeConfiguration
from acre_api.models.cdm_fee_fee_type import CdmFeeFeeType
from acre_api.models.cdm_file_type import CdmFileType
from acre_api.models.cdm_fingerprint import CdmFingerprint
from acre_api.models.cdm_first_time_access import CdmFirstTimeAccess
from acre_api.models.cdm_first_time_features import CdmFirstTimeFeatures
from acre_api.models.cdm_frequency import CdmFrequency
from acre_api.models.cdm_gender import CdmGender
from acre_api.models.cdm_general_insurance_product import CdmGeneralInsuranceProduct
from acre_api.models.cdm_general_insurance_product_details import CdmGeneralInsuranceProductDetails
from acre_api.models.cdm_generation import CdmGeneration
from acre_api.models.cdm_get_acre_mortgage_product_response import CdmGetAcreMortgageProductResponse
from acre_api.models.cdm_get_authentication_provider_request import CdmGetAuthenticationProviderRequest
from acre_api.models.cdm_get_authentication_provider_response import CdmGetAuthenticationProviderResponse
from acre_api.models.cdm_get_case_request import CdmGetCaseRequest
from acre_api.models.cdm_get_case_request_status import CdmGetCaseRequestStatus
from acre_api.models.cdm_get_case_response import CdmGetCaseResponse
from acre_api.models.cdm_get_case_survey_response import CdmGetCaseSurveyResponse
from acre_api.models.cdm_get_case_verifications_response import CdmGetCaseVerificationsResponse
from acre_api.models.cdm_get_case_version_response import CdmGetCaseVersionResponse
from acre_api.models.cdm_get_client_linked_data_response import CdmGetClientLinkedDataResponse
from acre_api.models.cdm_get_client_organisation_relationship_response import CdmGetClientOrganisationRelationshipResponse
from acre_api.models.cdm_get_client_request import CdmGetClientRequest
from acre_api.models.cdm_get_client_response import CdmGetClientResponse
from acre_api.models.cdm_get_client_verifications_response import CdmGetClientVerificationsResponse
from acre_api.models.cdm_get_client_version_response import CdmGetClientVersionResponse
from acre_api.models.cdm_get_commission_structure_request import CdmGetCommissionStructureRequest
from acre_api.models.cdm_get_commission_structure_response import CdmGetCommissionStructureResponse
from acre_api.models.cdm_get_document_requirements_response import CdmGetDocumentRequirementsResponse
from acre_api.models.cdm_get_document_response import CdmGetDocumentResponse
from acre_api.models.cdm_get_document_summaries_request import CdmGetDocumentSummariesRequest
from acre_api.models.cdm_get_document_summaries_response import CdmGetDocumentSummariesResponse
from acre_api.models.cdm_get_document_verification_request import CdmGetDocumentVerificationRequest
from acre_api.models.cdm_get_document_verification_response import CdmGetDocumentVerificationResponse
from acre_api.models.cdm_get_general_insurance_product_request import CdmGetGeneralInsuranceProductRequest
from acre_api.models.cdm_get_general_insurance_product_response import CdmGetGeneralInsuranceProductResponse
from acre_api.models.cdm_get_group_request import CdmGetGroupRequest
from acre_api.models.cdm_get_group_response import CdmGetGroupResponse
from acre_api.models.cdm_get_health_check_response import CdmGetHealthCheckResponse
from acre_api.models.cdm_get_me_response import CdmGetMeResponse
from acre_api.models.cdm_get_mortgage_product_details_response import CdmGetMortgageProductDetailsResponse
from acre_api.models.cdm_get_mortgage_request import CdmGetMortgageRequest
from acre_api.models.cdm_get_mortgage_response import CdmGetMortgageResponse
from acre_api.models.cdm_get_mortgage_version_response import CdmGetMortgageVersionResponse
from acre_api.models.cdm_get_note_request import CdmGetNoteRequest
from acre_api.models.cdm_get_note_response import CdmGetNoteResponse
from acre_api.models.cdm_get_organisation_request import CdmGetOrganisationRequest
from acre_api.models.cdm_get_organisation_response import CdmGetOrganisationResponse
from acre_api.models.cdm_get_permission_assignment_request import CdmGetPermissionAssignmentRequest
from acre_api.models.cdm_get_permission_assignment_response import CdmGetPermissionAssignmentResponse
from acre_api.models.cdm_get_permission_request import CdmGetPermissionRequest
from acre_api.models.cdm_get_permission_response import CdmGetPermissionResponse
from acre_api.models.cdm_get_property_request import CdmGetPropertyRequest
from acre_api.models.cdm_get_property_response import CdmGetPropertyResponse
from acre_api.models.cdm_get_property_version_response import CdmGetPropertyVersionResponse
from acre_api.models.cdm_get_protection_product_request import CdmGetProtectionProductRequest
from acre_api.models.cdm_get_protection_product_response import CdmGetProtectionProductResponse
from acre_api.models.cdm_get_protection_product_version_response import CdmGetProtectionProductVersionResponse
from acre_api.models.cdm_get_role_request import CdmGetRoleRequest
from acre_api.models.cdm_get_role_response import CdmGetRoleResponse
from acre_api.models.cdm_get_template_request import CdmGetTemplateRequest
from acre_api.models.cdm_get_template_response import CdmGetTemplateResponse
from acre_api.models.cdm_get_user_auth_url_response import CdmGetUserAuthURLResponse
from acre_api.models.cdm_get_user_request import CdmGetUserRequest
from acre_api.models.cdm_get_user_response import CdmGetUserResponse
from acre_api.models.cdm_gi import CdmGi
from acre_api.models.cdm_group import CdmGroup
from acre_api.models.cdm_health_check_report import CdmHealthCheckReport
from acre_api.models.cdm_hospital_list import CdmHospitalList
from acre_api.models.cdm_hydrated_case import CdmHydratedCase
from acre_api.models.cdm_hydrated_case_response import CdmHydratedCaseResponse
from acre_api.models.cdm_id_verification_status import CdmIDVerificationStatus
from acre_api.models.cdm_identity import CdmIdentity
from acre_api.models.cdm_indexation_type import CdmIndexationType
from acre_api.models.cdm_insurance_enbs_message import CdmInsuranceENBSMessage
from acre_api.models.cdm_intelliflo_creds import CdmIntellifloCreds
from acre_api.models.cdm_kba import CdmKBA
from acre_api.models.cdm_kba_status import CdmKBAStatus
from acre_api.models.cdm_lender_metadata import CdmLenderMetadata
from acre_api.models.cdm_linked_lead_case import CdmLinkedLeadCase
from acre_api.models.cdm_list_case_version_request import CdmListCaseVersionRequest
from acre_api.models.cdm_list_case_version_response import CdmListCaseVersionResponse
from acre_api.models.cdm_list_client_version_request import CdmListClientVersionRequest
from acre_api.models.cdm_list_client_version_response import CdmListClientVersionResponse
from acre_api.models.cdm_list_property_version_request import CdmListPropertyVersionRequest
from acre_api.models.cdm_list_property_version_response import CdmListPropertyVersionResponse
from acre_api.models.cdm_list_protection_product_version_request import CdmListProtectionProductVersionRequest
from acre_api.models.cdm_list_protection_product_version_response import CdmListProtectionProductVersionResponse
from acre_api.models.cdm_manual_case_flag import CdmManualCaseFlag
from acre_api.models.cdm_marketing_preferences import CdmMarketingPreferences
from acre_api.models.cdm_metadata import CdmMetadata
from acre_api.models.cdm_mortgage import CdmMortgage
from acre_api.models.cdm_mortgage_application_refused import CdmMortgageApplicationRefused
from acre_api.models.cdm_mortgage_arrears_summary import CdmMortgageArrearsSummary
from acre_api.models.cdm_mortgage_calculated_values import CdmMortgageCalculatedValues
from acre_api.models.cdm_mortgage_class import CdmMortgageClass
from acre_api.models.cdm_mortgage_enbs_message import CdmMortgageENBSMessage
from acre_api.models.cdm_mortgage_id_and_version import CdmMortgageIDAndVersion
from acre_api.models.cdm_mortgage_panel_limit_reason import CdmMortgagePanelLimitReason
from acre_api.models.cdm_mortgage_product_details import CdmMortgageProductDetails
from acre_api.models.cdm_mortgage_product_details_mortgage_type import CdmMortgageProductDetailsMortgageType
from acre_api.models.cdm_mortgage_product_fee import CdmMortgageProductFee
from acre_api.models.cdm_mortgage_product_fee_fee_type import CdmMortgageProductFeeFeeType
from acre_api.models.cdm_mortgage_status import CdmMortgageStatus
from acre_api.models.cdm_mortgage_term_unit import CdmMortgageTermUnit
from acre_api.models.cdm_mortgage_totals import CdmMortgageTotals
from acre_api.models.cdm_mortgage_type import CdmMortgageType
from acre_api.models.cdm_mortgage_with_product import CdmMortgageWithProduct
from acre_api.models.cdm_non_natural import CdmNonNatural
from acre_api.models.cdm_note import CdmNote
from acre_api.models.cdm_note_assignee_type import CdmNoteAssigneeType
from acre_api.models.cdm_note_note_status import CdmNoteNoteStatus
from acre_api.models.cdm_note_note_type import CdmNoteNoteType
from acre_api.models.cdm_note_template import CdmNoteTemplate
from acre_api.models.cdm_note_template_assignee import CdmNoteTemplateAssignee
from acre_api.models.cdm_note_template_assignee_type import CdmNoteTemplateAssigneeType
from acre_api.models.cdm_occupant import CdmOccupant
from acre_api.models.cdm_org_template_config import CdmOrgTemplateConfig
from acre_api.models.cdm_organisation import CdmOrganisation
from acre_api.models.cdm_organisation_status import CdmOrganisationStatus
from acre_api.models.cdm_organisation_verification_class import CdmOrganisationVerificationClass
from acre_api.models.cdm_origo_codes import CdmOrigoCodes
from acre_api.models.cdm_panel_management import CdmPanelManagement
from acre_api.models.cdm_payment_history import CdmPaymentHistory
from acre_api.models.cdm_payout_type import CdmPayoutType
from acre_api.models.cdm_period import CdmPeriod
from acre_api.models.cdm_periods_settings import CdmPeriodsSettings
from acre_api.models.cdm_permission import CdmPermission
from acre_api.models.cdm_permission_assignee import CdmPermissionAssignee
from acre_api.models.cdm_permission_assignee_assignee_type import CdmPermissionAssigneeAssigneeType
from acre_api.models.cdm_permission_assignment import CdmPermissionAssignment
from acre_api.models.cdm_permission_resolution_request import CdmPermissionResolutionRequest
from acre_api.models.cdm_permission_resolution_result import CdmPermissionResolutionResult
from acre_api.models.cdm_permission_scope import CdmPermissionScope
from acre_api.models.cdm_permission_type import CdmPermissionType
from acre_api.models.cdm_pmi import CdmPmi
from acre_api.models.cdm_premium_frequency import CdmPremiumFrequency
from acre_api.models.cdm_premium_type import CdmPremiumType
from acre_api.models.cdm_previous_name import CdmPreviousName
from acre_api.models.cdm_process_settings import CdmProcessSettings
from acre_api.models.cdm_product_benefit_add_ons import CdmProductBenefitAddOns
from acre_api.models.cdm_product_benefit_type_employee_benefit import CdmProductBenefitTypeEmployeeBenefit
from acre_api.models.cdm_product_benefit_type_family_income_benefit import CdmProductBenefitTypeFamilyIncomeBenefit
from acre_api.models.cdm_product_benefit_type_general import CdmProductBenefitTypeGeneral
from acre_api.models.cdm_product_benefit_type_income_protection import CdmProductBenefitTypeIncomeProtection
from acre_api.models.cdm_product_benefit_type_income_protection_cover_amount_type import CdmProductBenefitTypeIncomeProtectionCoverAmountType
from acre_api.models.cdm_product_benefit_type_other import CdmProductBenefitTypeOther
from acre_api.models.cdm_product_benefit_type_pmi import CdmProductBenefitTypePmi
from acre_api.models.cdm_product_benefit_type_private_medical_insurance import CdmProductBenefitTypePrivateMedicalInsurance
from acre_api.models.cdm_product_benefit_type_term import CdmProductBenefitTypeTerm
from acre_api.models.cdm_product_benefit_type_units import CdmProductBenefitTypeUnits
from acre_api.models.cdm_product_benefit_type_whole_of_life import CdmProductBenefitTypeWholeOfLife
from acre_api.models.cdm_product_order import CdmProductOrder
from acre_api.models.cdm_product_order_product_type import CdmProductOrderProductType
from acre_api.models.cdm_product_type import CdmProductType
from acre_api.models.cdm_property import CdmProperty
from acre_api.models.cdm_property_details import CdmPropertyDetails
from acre_api.models.cdm_property_details_property_tenure import CdmPropertyDetailsPropertyTenure
from acre_api.models.cdm_property_details_property_type import CdmPropertyDetailsPropertyType
from acre_api.models.cdm_property_id_and_version import CdmPropertyIDAndVersion
from acre_api.models.cdm_protection import CdmProtection
from acre_api.models.cdm_protection_commission import CdmProtectionCommission
from acre_api.models.cdm_protection_id_and_version import CdmProtectionIDAndVersion
from acre_api.models.cdm_protection_product import CdmProtectionProduct
from acre_api.models.cdm_protection_product_benefits import CdmProtectionProductBenefits
from acre_api.models.cdm_protection_product_details import CdmProtectionProductDetails
from acre_api.models.cdm_protection_product_details_status import CdmProtectionProductDetailsStatus
from acre_api.models.cdm_protection_product_documents import CdmProtectionProductDocuments
from acre_api.models.cdm_protection_product_not_proceeding import CdmProtectionProductNotProceeding
from acre_api.models.cdm_protection_requirements import CdmProtectionRequirements
from acre_api.models.cdm_protection_source import CdmProtectionSource
from acre_api.models.cdm_question import CdmQuestion
from acre_api.models.cdm_rmar_settings import CdmRMARSettings
from acre_api.models.cdm_rate_basis import CdmRateBasis
from acre_api.models.cdm_reason_for_mortgage import CdmReasonForMortgage
from acre_api.models.cdm_referral import CdmReferral
from acre_api.models.cdm_related_case import CdmRelatedCase
from acre_api.models.cdm_related_case_relationship_type import CdmRelatedCaseRelationshipType
from acre_api.models.cdm_related_user import CdmRelatedUser
from acre_api.models.cdm_related_user_relationship_type import CdmRelatedUserRelationshipType
from acre_api.models.cdm_render_template_request import CdmRenderTemplateRequest
from acre_api.models.cdm_render_template_response import CdmRenderTemplateResponse
from acre_api.models.cdm_replace_authentication_provider_response import CdmReplaceAuthenticationProviderResponse
from acre_api.models.cdm_replace_case_response import CdmReplaceCaseResponse
from acre_api.models.cdm_replace_client_response import CdmReplaceClientResponse
from acre_api.models.cdm_replace_document_response import CdmReplaceDocumentResponse
from acre_api.models.cdm_replace_group_response import CdmReplaceGroupResponse
from acre_api.models.cdm_replace_mortgage_response import CdmReplaceMortgageResponse
from acre_api.models.cdm_replace_organisation_response import CdmReplaceOrganisationResponse
from acre_api.models.cdm_replace_permission_assignment_response import CdmReplacePermissionAssignmentResponse
from acre_api.models.cdm_replace_property_response import CdmReplacePropertyResponse
from acre_api.models.cdm_replace_role_response import CdmReplaceRoleResponse
from acre_api.models.cdm_replace_user_response import CdmReplaceUserResponse
from acre_api.models.cdm_requirement_details import CdmRequirementDetails
from acre_api.models.cdm_requirement_details_status import CdmRequirementDetailsStatus
from acre_api.models.cdm_requirements_ip import CdmRequirementsIP
from acre_api.models.cdm_requirements_ip_cover_amount_type import CdmRequirementsIPCoverAmountType
from acre_api.models.cdm_requirements_lci_and_fib import CdmRequirementsLCIAndFIB
from acre_api.models.cdm_requirements_objectives import CdmRequirementsObjectives
from acre_api.models.cdm_requirements_pmi import CdmRequirementsPMI
from acre_api.models.cdm_requirements_wo_l import CdmRequirementsWoL
from acre_api.models.cdm_resolve_permission_request import CdmResolvePermissionRequest
from acre_api.models.cdm_resolve_permission_response import CdmResolvePermissionResponse
from acre_api.models.cdm_revenue_type import CdmRevenueType
from acre_api.models.cdm_review_body import CdmReviewBody
from acre_api.models.cdm_review_grade import CdmReviewGrade
from acre_api.models.cdm_role import CdmRole
from acre_api.models.cdm_run_id_verification_response import CdmRunIDVerificationResponse
from acre_api.models.cdm_run_source_request import CdmRunSourceRequest
from acre_api.models.cdm_run_source_response import CdmRunSourceResponse
from acre_api.models.cdm_sbg_provider_id import CdmSBGProviderID
from acre_api.models.cdm_sic2007 import CdmSIC2007
from acre_api.models.cdm_svr_rates import CdmSVRRates
from acre_api.models.cdm_save_protection_solution_to_case_request import CdmSaveProtectionSolutionToCaseRequest
from acre_api.models.cdm_save_protection_solution_to_case_response import CdmSaveProtectionSolutionToCaseResponse
from acre_api.models.cdm_schedule import CdmSchedule
from acre_api.models.cdm_source_applicant import CdmSourceApplicant
from acre_api.models.cdm_source_applicant_employment_status import CdmSourceApplicantEmploymentStatus
from acre_api.models.cdm_source_details import CdmSourceDetails
from acre_api.models.cdm_source_details_property_tenure import CdmSourceDetailsPropertyTenure
from acre_api.models.cdm_source_details_property_type import CdmSourceDetailsPropertyType
from acre_api.models.cdm_source_details_term_unit import CdmSourceDetailsTermUnit
from acre_api.models.cdm_specified_item import CdmSpecifiedItem
from acre_api.models.cdm_specified_item_type import CdmSpecifiedItemType
from acre_api.models.cdm_standard_fee_options import CdmStandardFeeOptions
from acre_api.models.cdm_supplementary_information import CdmSupplementaryInformation
from acre_api.models.cdm_survey_answer import CdmSurveyAnswer
from acre_api.models.cdm_template import CdmTemplate
from acre_api.models.cdm_template_context_request import CdmTemplateContextRequest
from acre_api.models.cdm_template_context_response import CdmTemplateContextResponse
from acre_api.models.cdm_template_name import CdmTemplateName
from acre_api.models.cdm_test_render_template_request import CdmTestRenderTemplateRequest
from acre_api.models.cdm_test_render_template_response import CdmTestRenderTemplateResponse
from acre_api.models.cdm_third_party_org import CdmThirdPartyOrg
from acre_api.models.cdm_threshold import CdmThreshold
from acre_api.models.cdm_threshold_conditions import CdmThresholdConditions
from acre_api.models.cdm_tier_commission import CdmTierCommission
from acre_api.models.cdm_title import CdmTitle
from acre_api.models.cdm_training_and_competency import CdmTrainingAndCompetency
from acre_api.models.cdm_transition_client_versions import CdmTransitionClientVersions
from acre_api.models.cdm_transition_mortgage_versions import CdmTransitionMortgageVersions
from acre_api.models.cdm_transition_property_versions import CdmTransitionPropertyVersions
from acre_api.models.cdm_transition_protection_versions import CdmTransitionProtectionVersions
from acre_api.models.cdm_underwriting_level import CdmUnderwritingLevel
from acre_api.models.cdm_unearned_income import CdmUnearnedIncome
from acre_api.models.cdm_update_authentication_provider_response import CdmUpdateAuthenticationProviderResponse
from acre_api.models.cdm_update_case_response import CdmUpdateCaseResponse
from acre_api.models.cdm_update_case_status_response import CdmUpdateCaseStatusResponse
from acre_api.models.cdm_update_client_organisation_relationship_response import CdmUpdateClientOrganisationRelationshipResponse
from acre_api.models.cdm_update_client_response import CdmUpdateClientResponse
from acre_api.models.cdm_update_commission_structure_response import CdmUpdateCommissionStructureResponse
from acre_api.models.cdm_update_document_requirement_response import CdmUpdateDocumentRequirementResponse
from acre_api.models.cdm_update_document_response import CdmUpdateDocumentResponse
from acre_api.models.cdm_update_general_insurance_product_response import CdmUpdateGeneralInsuranceProductResponse
from acre_api.models.cdm_update_group_response import CdmUpdateGroupResponse
from acre_api.models.cdm_update_mortgage_response import CdmUpdateMortgageResponse
from acre_api.models.cdm_update_mortgage_with_product_response import CdmUpdateMortgageWithProductResponse
from acre_api.models.cdm_update_note_response import CdmUpdateNoteResponse
from acre_api.models.cdm_update_organisation_response import CdmUpdateOrganisationResponse
from acre_api.models.cdm_update_permission_assignment_response import CdmUpdatePermissionAssignmentResponse
from acre_api.models.cdm_update_permission_assignments_request import CdmUpdatePermissionAssignmentsRequest
from acre_api.models.cdm_update_permission_assignments_response import CdmUpdatePermissionAssignmentsResponse
from acre_api.models.cdm_update_property_response import CdmUpdatePropertyResponse
from acre_api.models.cdm_update_protection_product_response import CdmUpdateProtectionProductResponse
from acre_api.models.cdm_update_role_response import CdmUpdateRoleResponse
from acre_api.models.cdm_update_user_response import CdmUpdateUserResponse
from acre_api.models.cdm_upload_document_request import CdmUploadDocumentRequest
from acre_api.models.cdm_upload_document_response import CdmUploadDocumentResponse
from acre_api.models.cdm_user import CdmUser
from acre_api.models.cdm_user_authentication import CdmUserAuthentication
from acre_api.models.cdm_user_status import CdmUserStatus
from acre_api.models.cdm_verification import CdmVerification
from acre_api.models.cdm_verification_class import CdmVerificationClass
from acre_api.models.cdm_verification_collection import CdmVerificationCollection
from acre_api.models.cdm_verification_description import CdmVerificationDescription
from acre_api.models.cdm_verification_result import CdmVerificationResult
from acre_api.models.cdm_verification_scope import CdmVerificationScope
from acre_api.models.cdm_verification_source_type import CdmVerificationSourceType
from acre_api.models.cdm_verification_type import CdmVerificationType
from acre_api.models.cdm_verified_disclosure_ids import CdmVerifiedDisclosureIDs
from acre_api.models.cdm_version_details import CdmVersionDetails
from acre_api.models.cdme_idv_result import CdmeIDVResult
from acre_api.models.client_address_residential_status import ClientAddressResidentialStatus
from acre_api.models.client_details_arrear import ClientDetailsArrear
from acre_api.models.client_details_bankruptcy_event import ClientDetailsBankruptcyEvent
from acre_api.models.client_details_client_type import ClientDetailsClientType
from acre_api.models.client_details_contact_method import ClientDetailsContactMethod
from acre_api.models.client_details_county_court_judgement import ClientDetailsCountyCourtJudgement
from acre_api.models.client_details_debt_management_plan import ClientDetailsDebtManagementPlan
from acre_api.models.client_details_individual_voluntary_arrangement import ClientDetailsIndividualVoluntaryArrangement
from acre_api.models.client_details_marital_status import ClientDetailsMaritalStatus
from acre_api.models.client_details_non_natural_organisation_type import ClientDetailsNonNaturalOrganisationType
from acre_api.models.client_details_residency_status import ClientDetailsResidencyStatus
from acre_api.models.client_details_vulnerability import ClientDetailsVulnerability
from acre_api.models.client_employment_income_employment_type import ClientEmploymentIncomeEmploymentType
from acre_api.models.client_income_detail_income_frequency import ClientIncomeDetailIncomeFrequency
from acre_api.models.client_income_detail_income_type import ClientIncomeDetailIncomeType
from acre_api.models.client_income_sick_pay import ClientIncomeSickPay
from acre_api.models.client_organisation_relationship_product_types import ClientOrganisationRelationshipProductTypes
from acre_api.models.client_organisation_relationship_relationship_types import ClientOrganisationRelationshipRelationshipTypes
from acre_api.models.client_outstanding_debt_account_status import ClientOutstandingDebtAccountStatus
from acre_api.models.client_outstanding_debt_borrower_type import ClientOutstandingDebtBorrowerType
from acre_api.models.client_outstanding_debt_commitment_type import ClientOutstandingDebtCommitmentType
from acre_api.models.client_outstanding_debt_repayment_status_type import ClientOutstandingDebtRepaymentStatusType
from acre_api.models.client_pension_income_pension_type import ClientPensionIncomePensionType
from acre_api.models.client_self_employment_income_accountant_qualifications import ClientSelfEmploymentIncomeAccountantQualifications
from acre_api.models.client_self_employment_income_self_employed_basis import ClientSelfEmploymentIncomeSelfEmployedBasis
from acre_api.models.commission_details_commission_payment_due import CommissionDetailsCommissionPaymentDue
from acre_api.models.complete_details_of_the_client_to_be_replaced_required import CompleteDetailsOfTheClientToBeReplacedRequired
from acre_api.models.complete_details_of_the_document_to_be_replaced_required import CompleteDetailsOfTheDocumentToBeReplacedRequired
from acre_api.models.complete_details_of_the_group_to_be_replaced_required import CompleteDetailsOfTheGroupToBeReplacedRequired
from acre_api.models.complete_details_of_the_mortgage_to_be_replaced_required import CompleteDetailsOfTheMortgageToBeReplacedRequired
from acre_api.models.complete_details_of_the_permission_assignment_to_be_replaced_currently_only_the_disabled_field_can_be_set_and_it_must_be_set_required import CompleteDetailsOfThePermissionAssignmentToBeReplacedCurrentlyOnlyTheDisabledFieldCanBeSetAndItMustBeSetRequired
from acre_api.models.complete_details_of_the_property_to_be_replaced_required import CompleteDetailsOfThePropertyToBeReplacedRequired
from acre_api.models.complete_details_of_the_role_to_be_replaced_required import CompleteDetailsOfTheRoleToBeReplacedRequired
from acre_api.models.contact_history_contact_type import ContactHistoryContactType
from acre_api.models.credit_report_retrievals_matches import CreditReportRetrievalsMatches
from acre_api.models.document_document_source_type import DocumentDocumentSourceType
from acre_api.models.document_document_type import DocumentDocumentType
from acre_api.models.editor_editor_types import EditorEditorTypes
from acre_api.models.event_note_event_note_type import EventNoteEventNoteType
from acre_api.models.external_id_source_name import ExternalIDSourceName
from acre_api.models.external_source import ExternalSource
from acre_api.models.full_details_of_the_authentication_provider_to_be_replaced_required import FullDetailsOfTheAuthenticationProviderToBeReplacedRequired
from acre_api.models.full_details_of_the_user_to_be_replaced_required import FullDetailsOfTheUserToBeReplacedRequired
from acre_api.models.general_insurance_product_details_gi_product_status import GeneralInsuranceProductDetailsGIProductStatus
from acre_api.models.general_insurance_product_details_gi_product_type import GeneralInsuranceProductDetailsGIProductType
from acre_api.models.general_insurance_product_details_years_no_claims import GeneralInsuranceProductDetailsYearsNoClaims
from acre_api.models.googleprotobuf_any import GoogleprotobufAny
from acre_api.models.googlerpc_status import GooglerpcStatus
from acre_api.models.hydrated_case_mortgage_pair import HydratedCaseMortgagePair
from acre_api.models.kba_ran_from import KBARanFrom
from acre_api.models.minimal_details_of_flag_to_add_required import MinimalDetailsOfFlagToAddRequired
from acre_api.models.mortgage_application_refused_application_refused_type import MortgageApplicationRefusedApplicationRefusedType
from acre_api.models.mortgage_calculated_values_calculated_club_proc_fee import MortgageCalculatedValuesCalculatedClubProcFee
from acre_api.models.mortgage_dip_status_type import MortgageDipStatusType
from acre_api.models.mortgage_fees_to_be_added import MortgageFeesToBeAdded
from acre_api.models.mortgage_loan_purpose import MortgageLoanPurpose
from acre_api.models.mortgage_product_and_sourcing_details_to_update import MortgageProductAndSourcingDetailsToUpdate
from acre_api.models.mortgage_product_details_mortgage_club_proc_fee import MortgageProductDetailsMortgageClubProcFee
from acre_api.models.mortgage_product_details_rate_tier import MortgageProductDetailsRateTier
from acre_api.models.mortgage_product_details_stress_test_payment import MortgageProductDetailsStressTestPayment
from acre_api.models.mortgage_product_fee_can_be_added_to_loan import MortgageProductFeeCanBeAddedToLoan
from acre_api.models.mortgage_product_fee_timing import MortgageProductFeeTiming
from acre_api.models.mortgage_valuation_type import MortgageValuationType
from acre_api.models.note_communication_type import NoteCommunicationType
from acre_api.models.note_event_note import NoteEventNote
from acre_api.models.note_ui_reference import NoteUiReference
from acre_api.models.occupant_relationship import OccupantRelationship
from acre_api.models.occupant_tenancy_type import OccupantTenancyType
from acre_api.models.occupant_tenant_type import OccupantTenantType
from acre_api.models.organisation_client_portal_settings import OrganisationClientPortalSettings
from acre_api.models.organisation_legal_form import OrganisationLegalForm
from acre_api.models.organisation_organisation_type import OrganisationOrganisationType
from acre_api.models.panel_management_panel import PanelManagementPanel
from acre_api.models.partial_details_of_the_authentication_provider_to_be_patched_required import PartialDetailsOfTheAuthenticationProviderToBePatchedRequired
from acre_api.models.partial_details_of_the_case_to_be_patched_required import PartialDetailsOfTheCaseToBePatchedRequired
from acre_api.models.partial_details_of_the_client_to_be_patched_required import PartialDetailsOfTheClientToBePatchedRequired
from acre_api.models.partial_details_of_the_commission_structure_to_be_patched_required import PartialDetailsOfTheCommissionStructureToBePatchedRequired
from acre_api.models.partial_details_of_the_document_to_be_patched_required import PartialDetailsOfTheDocumentToBePatchedRequired
from acre_api.models.partial_details_of_the_group_to_be_patched_required import PartialDetailsOfTheGroupToBePatchedRequired
from acre_api.models.partial_details_of_the_mortgage_to_be_replaced_required import PartialDetailsOfTheMortgageToBeReplacedRequired
from acre_api.models.partial_details_of_the_mortgage_to_be_replaced_required1 import PartialDetailsOfTheMortgageToBeReplacedRequired1
from acre_api.models.partial_details_of_the_note_to_be_updated import PartialDetailsOfTheNoteToBeUpdated
from acre_api.models.partial_details_of_the_permission_assignment_to_be_patched_currently_only_the_disabled_field_can_be_set_and_it_must_be_set_required import PartialDetailsOfThePermissionAssignmentToBePatchedCurrentlyOnlyTheDisabledFieldCanBeSetAndItMustBeSetRequired
from acre_api.models.partial_details_of_the_product_to_be_updated_required import PartialDetailsOfTheProductToBeUpdatedRequired
from acre_api.models.partial_details_of_the_property_to_be_replaced_required import PartialDetailsOfThePropertyToBeReplacedRequired
from acre_api.models.partial_details_of_the_protection_product_to_be_updated_required import PartialDetailsOfTheProtectionProductToBeUpdatedRequired
from acre_api.models.partial_details_of_the_role_to_be_patched_required import PartialDetailsOfTheRoleToBePatchedRequired
from acre_api.models.partial_details_of_the_user_to_be_patched_required import PartialDetailsOfTheUserToBePatchedRequired
from acre_api.models.payment_history_credit_limit_change import PaymentHistoryCreditLimitChange
from acre_api.models.payment_history_payment_history_status_type import PaymentHistoryPaymentHistoryStatusType
from acre_api.models.property_details_builder_registration_scheme import PropertyDetailsBuilderRegistrationScheme
from acre_api.models.property_details_energy_rating import PropertyDetailsEnergyRating
from acre_api.models.property_details_property_location import PropertyDetailsPropertyLocation
from acre_api.models.property_details_property_parking import PropertyDetailsPropertyParking
from acre_api.models.property_details_property_sub_type import PropertyDetailsPropertySubType
from acre_api.models.property_details_property_use import PropertyDetailsPropertyUse
from acre_api.models.property_details_property_valuation_source import PropertyDetailsPropertyValuationSource
from acre_api.models.property_details_property_work import PropertyDetailsPropertyWork
from acre_api.models.property_details_roof_type import PropertyDetailsRoofType
from acre_api.models.property_details_shared_ownership_type import PropertyDetailsSharedOwnershipType
from acre_api.models.property_details_wall_type import PropertyDetailsWallType
from acre_api.models.protection_commission_renewal_commission_frequency import ProtectionCommissionRenewalCommissionFrequency
from acre_api.models.protection_product_details_solution_type import ProtectionProductDetailsSolutionType
from acre_api.models.protection_product_not_proceeding_entity_type import ProtectionProductNotProceedingEntityType
from acre_api.models.question_event_trigger import QuestionEventTrigger
from acre_api.models.question_event_trigger_type import QuestionEventTriggerType
from acre_api.models.question_question_type import QuestionQuestionType
from acre_api.models.referral_email_tracking_status import ReferralEmailTrackingStatus
from acre_api.models.referral_referral_partner import ReferralReferralPartner
from acre_api.models.referral_referral_source import ReferralReferralSource
from acre_api.models.referral_referral_status import ReferralReferralStatus
from acre_api.models.referral_referral_type import ReferralReferralType
from acre_api.models.requirements_lci_and_fib_benefit_type import RequirementsLCIAndFIBBenefitType
from acre_api.models.requirements_lci_and_fib_scenario import RequirementsLCIAndFIBScenario
from acre_api.models.sick_pay_sick_pay_type import SickPaySickPayType
from acre_api.models.source_applicant_nationality import SourceApplicantNationality
from acre_api.models.source_details_buy_to_let_refurbishment_type import SourceDetailsBuyToLetRefurbishmentType
from acre_api.models.source_details_column import SourceDetailsColumn
from acre_api.models.source_details_direction import SourceDetailsDirection
from acre_api.models.source_details_landlord_status import SourceDetailsLandlordStatus
from acre_api.models.source_details_payment_method import SourceDetailsPaymentMethod
from acre_api.models.source_details_reason_for_remortgage import SourceDetailsReasonForRemortgage
from acre_api.models.source_details_search_matching_type import SourceDetailsSearchMatchingType
from acre_api.models.source_details_sort_column import SourceDetailsSortColumn
from acre_api.models.source_details_tenant_status import SourceDetailsTenantStatus
from acre_api.models.source_name import SourceName
from acre_api.models.srv_acre_processor_add_case_document_body import SrvAcreProcessorAddCaseDocumentBody
from acre_api.models.srv_acre_processor_add_mortgage_case_body import SrvAcreProcessorAddMortgageCaseBody
from acre_api.models.srv_acre_processor_add_mortgage_product_body import SrvAcreProcessorAddMortgageProductBody
from acre_api.models.srv_acre_processor_create_document_verification_body import SrvAcreProcessorCreateDocumentVerificationBody
from acre_api.models.the_full_details_of_the_case_to_be_replaced_required import TheFullDetailsOfTheCaseToBeReplacedRequired
from acre_api.models.the_requirement_to_be_updated import TheRequirementToBeUpdated
from acre_api.models.third_party_org_third_party_type import ThirdPartyOrgThirdPartyType
from acre_api.models.threshold_conditions_notifiable_change import ThresholdConditionsNotifiableChange
from acre_api.models.training_and_competency_equity_release_qualification import TrainingAndCompetencyEquityReleaseQualification
from acre_api.models.training_and_competency_mortgage_qualification import TrainingAndCompetencyMortgageQualification
from acre_api.models.training_and_competency_protection_qualification import TrainingAndCompetencyProtectionQualification
from acre_api.models.ui_reference_section import UiReferenceSection
from acre_api.models.unearned_income_unearned_income_frequency import UnearnedIncomeUnearnedIncomeFrequency
from acre_api.models.unearned_income_unearned_income_type import UnearnedIncomeUnearnedIncomeType
from acre_api.models.v1_exception import V1Exception
from acre_api.models.v1_exception_response import V1ExceptionResponse
from acre_api.models.v1_exception_type import V1ExceptionType
from acre_api.models.verification_flag_status import VerificationFlagStatus
