# coding: utf-8

"""
    Acre Platform User API

    # CORS CORS is implemented by all Acre API endpoints and only certain hostnames are allowed for each deployment of the API. If your use case requires calling the Acre User API from a browser, please contact Acre to arrange the appropriate configuration. # API Authentication The primary method of authentication for users of the Acre API is with the use of JSON Web Tokens (JWTs), which are suplemented by an application specific API Key. The API key must be provided through the `X-API-KEY` HTTP header and will be provided by your Acre Customer Success Manager. The JWT must be provided through a cookie with key of `authorization`. The JWT must be generated and signed as per the following section. # Generating JWTs JWT must either be generated by a third-party such as Azure ADB2C that has been configured for the appropriate service and/or user account, or alternatively can be generated locally and signed by an private key for which the public key has been made available to Acre via a JWKS URL. In addition to being signed by your private key, the JWT will also need to contain at a minimum:  * An issuer `iss`, which must be a valid URI previously agreed with Acre.  * A subject `sub`, which must be a unique identifier for the user and/or service account previously agreed with Acre.  * An expiry time `exp` which must not be more than four hours in the future.  * A not before time `nbf` which must be in the past, but not greater than six hours in the past.  The JWT should be signed using RS256.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from acre_api.models.cdm_case_details_note_assignee_type import CdmCaseDetailsNoteAssigneeType
from acre_api.models.cdm_case_details_note_note_status import CdmCaseDetailsNoteNoteStatus
from acre_api.models.cdm_case_details_note_note_type import CdmCaseDetailsNoteNoteType
from typing import Optional, Set
from typing_extensions import Self

class CdmCaseDetailsNote(BaseModel):
    """
    **DEPRECATED** Notes are their own entities and inner case notes are deprecated.  Note contains information on a case note.
    """ # noqa: E501
    title: Optional[StrictStr] = Field(default=None, description="A quick reference title for the note.")
    created_at: Optional[StrictStr] = Field(default=None, description="The timestamp of when the note was created. This field is auto-populated and cannot be user edited.")
    updated_at: Optional[StrictStr] = Field(default=None, description="The last time the note was updated. This field is auto-populated and cannot be user edited.")
    priority: Optional[StrictInt] = Field(default=None, description="Used by the frontend to determine the order in which the notes will appear.")
    status: Optional[CdmCaseDetailsNoteNoteStatus] = CdmCaseDetailsNoteNoteStatus.INVALID_NOTE_STATUS
    body: Optional[StrictStr] = Field(default=None, description="The notes themselves.")
    primary_type: Optional[CdmCaseDetailsNoteNoteType] = CdmCaseDetailsNoteNoteType.INVALID_NOTE_TYPE
    deadline: Optional[StrictStr] = Field(default=None, description="When the action is due (RFC3339).")
    assignee_id: Optional[StrictStr] = Field(default=None, description="User, group or client to whom a given reminder is assigned.")
    assignee_type: Optional[CdmCaseDetailsNoteAssigneeType] = CdmCaseDetailsNoteAssigneeType.INVALID_ASSIGNEE_TYPE
    __properties: ClassVar[List[str]] = ["title", "created_at", "updated_at", "priority", "status", "body", "primary_type", "deadline", "assignee_id", "assignee_type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CdmCaseDetailsNote from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CdmCaseDetailsNote from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "title": obj.get("title"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "priority": obj.get("priority"),
            "status": obj.get("status") if obj.get("status") is not None else CdmCaseDetailsNoteNoteStatus.INVALID_NOTE_STATUS,
            "body": obj.get("body"),
            "primary_type": obj.get("primary_type") if obj.get("primary_type") is not None else CdmCaseDetailsNoteNoteType.INVALID_NOTE_TYPE,
            "deadline": obj.get("deadline"),
            "assignee_id": obj.get("assignee_id"),
            "assignee_type": obj.get("assignee_type") if obj.get("assignee_type") is not None else CdmCaseDetailsNoteAssigneeType.INVALID_ASSIGNEE_TYPE
        })
        return _obj


