# coding: utf-8

"""
    Acre Platform User API

    # CORS CORS is implemented by all Acre API endpoints and only certain hostnames are allowed for each deployment of the API. If your use case requires calling the Acre User API from a browser, please contact Acre to arrange the appropriate configuration. # API Authentication The primary method of authentication for users of the Acre API is with the use of JSON Web Tokens (JWTs), which are suplemented by an application specific API Key. The API key must be provided through the `X-API-KEY` HTTP header and will be provided by your Acre Customer Success Manager. The JWT must be provided through a cookie with key of `authorization`. The JWT must be generated and signed as per the following section. # Generating JWTs JWT must either be generated by a third-party such as Azure ADB2C that has been configured for the appropriate service and/or user account, or alternatively can be generated locally and signed by an private key for which the public key has been made available to Acre via a JWKS URL. In addition to being signed by your private key, the JWT will also need to contain at a minimum:  * An issuer `iss`, which must be a valid URI previously agreed with Acre.  * A subject `sub`, which must be a unique identifier for the user and/or service account previously agreed with Acre.  * An expiry time `exp` which must not be more than four hours in the future.  * A not before time `nbf` which must be in the past, but not greater than six hours in the past.  The JWT should be signed using RS256.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from acre_api.models.cdm_credit_search_consent import CdmCreditSearchConsent
from acre_api.models.cdm_marketing_preferences import CdmMarketingPreferences
from acre_api.models.cdm_verified_disclosure_ids import CdmVerifiedDisclosureIDs
from acre_api.models.client_organisation_relationship_product_types import ClientOrganisationRelationshipProductTypes
from acre_api.models.client_organisation_relationship_relationship_types import ClientOrganisationRelationshipRelationshipTypes
from typing import Optional, Set
from typing_extensions import Self

class CdmClientOrganisationRelationship(BaseModel):
    """
    ClientOrganisationRelationship defines features in a client x organisation relationship. ClientOrganisationRelationship is unique for a org_id-client_id combination.
    """ # noqa: E501
    client_id: Optional[StrictStr] = None
    org_id: Optional[StrictStr] = None
    marketing_preferences: Optional[List[CdmMarketingPreferences]] = None
    credit_search_consents: Optional[List[CdmCreditSearchConsent]] = None
    verified_document_disclosure_ids: Optional[CdmVerifiedDisclosureIDs] = None
    relationship_type: Optional[ClientOrganisationRelationshipRelationshipTypes] = ClientOrganisationRelationshipRelationshipTypes.INVALID_RELATIONSHIP
    product_types: Optional[List[ClientOrganisationRelationshipProductTypes]] = None
    client_max_version: Optional[StrictInt] = Field(default=None, description="client_max_version is the max client version an org has access to (default nil).")
    client_min_version: Optional[StrictInt] = Field(default=None, description="client_min_version is the min client version an org has access to (default nil).")
    __properties: ClassVar[List[str]] = ["client_id", "org_id", "marketing_preferences", "credit_search_consents", "verified_document_disclosure_ids", "relationship_type", "product_types", "client_max_version", "client_min_version"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CdmClientOrganisationRelationship from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in marketing_preferences (list)
        _items = []
        if self.marketing_preferences:
            for _item_marketing_preferences in self.marketing_preferences:
                if _item_marketing_preferences:
                    _items.append(_item_marketing_preferences.to_dict())
            _dict['marketing_preferences'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in credit_search_consents (list)
        _items = []
        if self.credit_search_consents:
            for _item_credit_search_consents in self.credit_search_consents:
                if _item_credit_search_consents:
                    _items.append(_item_credit_search_consents.to_dict())
            _dict['credit_search_consents'] = _items
        # override the default output from pydantic by calling `to_dict()` of verified_document_disclosure_ids
        if self.verified_document_disclosure_ids:
            _dict['verified_document_disclosure_ids'] = self.verified_document_disclosure_ids.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CdmClientOrganisationRelationship from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "client_id": obj.get("client_id"),
            "org_id": obj.get("org_id"),
            "marketing_preferences": [CdmMarketingPreferences.from_dict(_item) for _item in obj["marketing_preferences"]] if obj.get("marketing_preferences") is not None else None,
            "credit_search_consents": [CdmCreditSearchConsent.from_dict(_item) for _item in obj["credit_search_consents"]] if obj.get("credit_search_consents") is not None else None,
            "verified_document_disclosure_ids": CdmVerifiedDisclosureIDs.from_dict(obj["verified_document_disclosure_ids"]) if obj.get("verified_document_disclosure_ids") is not None else None,
            "relationship_type": obj.get("relationship_type") if obj.get("relationship_type") is not None else ClientOrganisationRelationshipRelationshipTypes.INVALID_RELATIONSHIP,
            "product_types": obj.get("product_types"),
            "client_max_version": obj.get("client_max_version"),
            "client_min_version": obj.get("client_min_version")
        })
        return _obj


