# coding: utf-8

"""
    Acre Platform User API

    # CORS CORS is implemented by all Acre API endpoints and only certain hostnames are allowed for each deployment of the API. If your use case requires calling the Acre User API from a browser, please contact Acre to arrange the appropriate configuration. # API Authentication The primary method of authentication for users of the Acre API is with the use of JSON Web Tokens (JWTs), which are suplemented by an application specific API Key. The API key must be provided through the `X-API-KEY` HTTP header and will be provided by your Acre Customer Success Manager. The JWT must be provided through a cookie with key of `authorization`. The JWT must be generated and signed as per the following section. # Generating JWTs JWT must either be generated by a third-party such as Azure ADB2C that has been configured for the appropriate service and/or user account, or alternatively can be generated locally and signed by an private key for which the public key has been made available to Acre via a JWKS URL. In addition to being signed by your private key, the JWT will also need to contain at a minimum:  * An issuer `iss`, which must be a valid URI previously agreed with Acre.  * A subject `sub`, which must be a unique identifier for the user and/or service account previously agreed with Acre.  * An expiry time `exp` which must not be more than four hours in the future.  * A not before time `nbf` which must be in the past, but not greater than six hours in the past.  The JWT should be signed using RS256.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from acre_api.models.cdm_mortgage import CdmMortgage
from acre_api.models.cdm_mortgage_product_details import CdmMortgageProductDetails
from acre_api.models.cdm_run_source_response import CdmRunSourceResponse
from typing import Optional, Set
from typing_extensions import Self

class CdmCreateMortgageWithProductRequest(BaseModel):
    """
    Create a mortgage and product within Acre, and link to case if ID supplied.
    """ # noqa: E501
    case_id: Optional[StrictStr] = Field(default=None, description="ID of the case to link the mortgage to.")
    mortgage: CdmMortgage
    product_details: Optional[CdmMortgageProductDetails] = None
    source_response: Optional[CdmRunSourceResponse] = None
    product_source_rank: Optional[StrictInt] = Field(default=None, description="Rank of the product in the source response.")
    product_select_reason: Optional[StrictStr] = Field(default=None, description="Reason for selecting the mortgage.")
    __properties: ClassVar[List[str]] = ["case_id", "mortgage", "product_details", "source_response", "product_source_rank", "product_select_reason"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CdmCreateMortgageWithProductRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of mortgage
        if self.mortgage:
            _dict['mortgage'] = self.mortgage.to_dict()
        # override the default output from pydantic by calling `to_dict()` of product_details
        if self.product_details:
            _dict['product_details'] = self.product_details.to_dict()
        # override the default output from pydantic by calling `to_dict()` of source_response
        if self.source_response:
            _dict['source_response'] = self.source_response.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CdmCreateMortgageWithProductRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "case_id": obj.get("case_id"),
            "mortgage": CdmMortgage.from_dict(obj["mortgage"]) if obj.get("mortgage") is not None else None,
            "product_details": CdmMortgageProductDetails.from_dict(obj["product_details"]) if obj.get("product_details") is not None else None,
            "source_response": CdmRunSourceResponse.from_dict(obj["source_response"]) if obj.get("source_response") is not None else None,
            "product_source_rank": obj.get("product_source_rank"),
            "product_select_reason": obj.get("product_select_reason")
        })
        return _obj


