# coding: utf-8

"""
    Acre Platform User API

    # CORS CORS is implemented by all Acre API endpoints and only certain hostnames are allowed for each deployment of the API. If your use case requires calling the Acre User API from a browser, please contact Acre to arrange the appropriate configuration. # API Authentication The primary method of authentication for users of the Acre API is with the use of JSON Web Tokens (JWTs), which are suplemented by an application specific API Key. The API key must be provided through the `X-API-KEY` HTTP header and will be provided by your Acre Customer Success Manager. The JWT must be provided through a cookie with key of `authorization`. The JWT must be generated and signed as per the following section. # Generating JWTs JWT must either be generated by a third-party such as Azure ADB2C that has been configured for the appropriate service and/or user account, or alternatively can be generated locally and signed by an private key for which the public key has been made available to Acre via a JWKS URL. In addition to being signed by your private key, the JWT will also need to contain at a minimum:  * An issuer `iss`, which must be a valid URI previously agreed with Acre.  * A subject `sub`, which must be a unique identifier for the user and/or service account previously agreed with Acre.  * An expiry time `exp` which must not be more than four hours in the future.  * A not before time `nbf` which must be in the past, but not greater than six hours in the past.  The JWT should be signed using RS256.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from acre_api.models.cdm_mortgage_product_fee_fee_type import CdmMortgageProductFeeFeeType
from acre_api.models.mortgage_product_fee_can_be_added_to_loan import MortgageProductFeeCanBeAddedToLoan
from acre_api.models.mortgage_product_fee_timing import MortgageProductFeeTiming
from typing import Optional, Set
from typing_extensions import Self

class CdmMortgageProductFee(BaseModel):
    """
    Fee data that IRESS provides.
    """ # noqa: E501
    min_amount: Optional[StrictStr] = Field(default=None, description="The min fee amount.")
    max_amount: Optional[StrictStr] = Field(default=None, description="The max fee amount.")
    percentage: Optional[StrictInt] = Field(default=None, description="The fee based on this percentage of the loan, represented as 1/100000 of a percent (precision for up to 5 decimal places).")
    amount: Optional[StrictStr] = Field(default=None, description="The fee amount.")
    can_be_added_to_loan: Optional[MortgageProductFeeCanBeAddedToLoan] = MortgageProductFeeCanBeAddedToLoan.INVALID_CAN_BE_ADDED_TO_LOAN
    timing: Optional[MortgageProductFeeTiming] = MortgageProductFeeTiming.INVALID_TIMING
    refundable: Optional[StrictBool] = Field(default=None, description="Indicates if the fee is refundable.")
    fee_type: Optional[CdmMortgageProductFeeFeeType] = CdmMortgageProductFeeFeeType.INVALID_FEE_TYPE
    other_type: Optional[StrictStr] = Field(default=None, description="Description of other fee types.")
    payable_to: Optional[StrictStr] = Field(default=None, description="Details of who the fee is payable to.")
    notes: Optional[StrictStr] = Field(default=None, description="Provider fee notes.")
    __properties: ClassVar[List[str]] = ["min_amount", "max_amount", "percentage", "amount", "can_be_added_to_loan", "timing", "refundable", "fee_type", "other_type", "payable_to", "notes"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CdmMortgageProductFee from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CdmMortgageProductFee from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "min_amount": obj.get("min_amount"),
            "max_amount": obj.get("max_amount"),
            "percentage": obj.get("percentage"),
            "amount": obj.get("amount"),
            "can_be_added_to_loan": obj.get("can_be_added_to_loan") if obj.get("can_be_added_to_loan") is not None else MortgageProductFeeCanBeAddedToLoan.INVALID_CAN_BE_ADDED_TO_LOAN,
            "timing": obj.get("timing") if obj.get("timing") is not None else MortgageProductFeeTiming.INVALID_TIMING,
            "refundable": obj.get("refundable"),
            "fee_type": obj.get("fee_type") if obj.get("fee_type") is not None else CdmMortgageProductFeeFeeType.INVALID_FEE_TYPE,
            "other_type": obj.get("other_type"),
            "payable_to": obj.get("payable_to"),
            "notes": obj.get("notes")
        })
        return _obj


