# coding: utf-8

"""
    Acre Platform User API

    # CORS CORS is implemented by all Acre API endpoints and only certain hostnames are allowed for each deployment of the API. If your use case requires calling the Acre User API from a browser, please contact Acre to arrange the appropriate configuration. # API Authentication The primary method of authentication for users of the Acre API is with the use of JSON Web Tokens (JWTs), which are suplemented by an application specific API Key. The API key must be provided through the `X-API-KEY` HTTP header and will be provided by your Acre Customer Success Manager. The JWT must be provided through a cookie with key of `authorization`. The JWT must be generated and signed as per the following section. # Generating JWTs JWT must either be generated by a third-party such as Azure ADB2C that has been configured for the appropriate service and/or user account, or alternatively can be generated locally and signed by an private key for which the public key has been made available to Acre via a JWKS URL. In addition to being signed by your private key, the JWT will also need to contain at a minimum:  * An issuer `iss`, which must be a valid URI previously agreed with Acre.  * A subject `sub`, which must be a unique identifier for the user and/or service account previously agreed with Acre.  * An expiry time `exp` which must not be more than four hours in the future.  * A not before time `nbf` which must be in the past, but not greater than six hours in the past.  The JWT should be signed using RS256.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class CdmMortgageProductFeeFeeType(str, Enum):
    """
    CdmMortgageProductFeeFeeType
    """

    """
    allowed enum values
    """
    INVALID_FEE_TYPE = 'INVALID_FEE_TYPE'
    TITLE_DEEDS_ADMIN_FEE = 'TITLE_DEEDS_ADMIN_FEE'
    LEGAL_FEE = 'LEGAL_FEE'
    VALUATION_FEE = 'VALUATION_FEE'
    HIGHER_LENDING_CHARGE = 'HIGHER_LENDING_CHARGE'
    LENDER_CONVEYANCING_FEE = 'LENDER_CONVEYANCING_FEE'
    BOOKING_FEE = 'BOOKING_FEE'
    ARRANGEMENT_FEE = 'ARRANGEMENT_FEE'
    APPLICATION_FEE = 'APPLICATION_FEE'
    COMPLETION_FEE = 'COMPLETION_FEE'
    ADMINISTRATION_FEE = 'ADMINISTRATION_FEE'
    INSURANCE_ADMINISTRATION = 'INSURANCE_ADMINISTRATION'
    LAND_REGISTRY_FEE = 'LAND_REGISTRY_FEE'
    MORTGAGE_ACCOUNT_FEE = 'MORTGAGE_ACCOUNT_FEE'
    MASTER_BROKER_FEE = 'MASTER_BROKER_FEE'
    PACKAGER_FEE = 'PACKAGER_FEE'
    PRODUCT_TRANSFER_FEE = 'PRODUCT_TRANSFER_FEE'
    RE_INSPECTION_FEE = 'RE_INSPECTION_FEE'
    CHAPS_TELEGRAPHIC_TRANSFER_FEE = 'CHAPS_TELEGRAPHIC_TRANSFER_FEE'
    REDEMPTION_ADMIN_FEE = 'REDEMPTION_ADMIN_FEE'
    BROKER_FEE = 'BROKER_FEE'
    EARLY_REPAYMENT_CHARGE = 'EARLY_REPAYMENT_CHARGE'
    DEEDS_RELEASE_FEE = 'DEEDS_RELEASE_FEE'
    OTHER_FEE = 'OTHER_FEE'
    ASSESSMENT_FEE = 'ASSESSMENT_FEE'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CdmMortgageProductFeeFeeType from a JSON string"""
        return cls(json.loads(json_str))


