# coding: utf-8

"""
    Acre Platform User API

    # CORS CORS is implemented by all Acre API endpoints and only certain hostnames are allowed for each deployment of the API. If your use case requires calling the Acre User API from a browser, please contact Acre to arrange the appropriate configuration. # API Authentication The primary method of authentication for users of the Acre API is with the use of JSON Web Tokens (JWTs), which are suplemented by an application specific API Key. The API key must be provided through the `X-API-KEY` HTTP header and will be provided by your Acre Customer Success Manager. The JWT must be provided through a cookie with key of `authorization`. The JWT must be generated and signed as per the following section. # Generating JWTs JWT must either be generated by a third-party such as Azure ADB2C that has been configured for the appropriate service and/or user account, or alternatively can be generated locally and signed by an private key for which the public key has been made available to Acre via a JWKS URL. In addition to being signed by your private key, the JWT will also need to contain at a minimum:  * An issuer `iss`, which must be a valid URI previously agreed with Acre.  * A subject `sub`, which must be a unique identifier for the user and/or service account previously agreed with Acre.  * An expiry time `exp` which must not be more than four hours in the future.  * A not before time `nbf` which must be in the past, but not greater than six hours in the past.  The JWT should be signed using RS256.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from acre_api.models.case_details_mortgage_reason import CaseDetailsMortgageReason
from acre_api.models.cdm_note_note_type import CdmNoteNoteType
from acre_api.models.cdm_note_template_assignee import CdmNoteTemplateAssignee
from typing import Optional, Set
from typing_extensions import Self

class CdmNoteTemplate(BaseModel):
    """
    Note template contains fields specifying when the note template is relevant and default values for Acre Notes created from the template.
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="Unique Id of the note template (autopopulated).")
    title: Optional[StrictStr] = Field(default=None, description="Title of the template - required.")
    disabled: Optional[StrictBool] = Field(default=None, description="Whether the note template has been disabled.")
    note_type: Optional[CdmNoteNoteType] = CdmNoteNoteType.INVALID_NOTE_TYPE
    case_types: Optional[List[CaseDetailsMortgageReason]] = Field(default=None, description="Case types to which the note template applies.")
    default_assignees: Optional[List[CdmNoteTemplateAssignee]] = Field(default=None, description="Default assignees for the note created from the template (max length 1).")
    default_delay_minutes: Optional[StrictInt] = Field(default=None, description="Default delay in minutes to calculate the note deadline when creating from template.")
    default_priority: Optional[StrictInt] = Field(default=None, description="Default priority is the priority for note when creating from template.")
    body: Optional[StrictStr] = Field(default=None, description="The body of the template.")
    __properties: ClassVar[List[str]] = ["id", "title", "disabled", "note_type", "case_types", "default_assignees", "default_delay_minutes", "default_priority", "body"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CdmNoteTemplate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in default_assignees (list)
        _items = []
        if self.default_assignees:
            for _item_default_assignees in self.default_assignees:
                if _item_default_assignees:
                    _items.append(_item_default_assignees.to_dict())
            _dict['default_assignees'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CdmNoteTemplate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "title": obj.get("title"),
            "disabled": obj.get("disabled"),
            "note_type": obj.get("note_type") if obj.get("note_type") is not None else CdmNoteNoteType.INVALID_NOTE_TYPE,
            "case_types": obj.get("case_types"),
            "default_assignees": [CdmNoteTemplateAssignee.from_dict(_item) for _item in obj["default_assignees"]] if obj.get("default_assignees") is not None else None,
            "default_delay_minutes": obj.get("default_delay_minutes"),
            "default_priority": obj.get("default_priority"),
            "body": obj.get("body")
        })
        return _obj


