# coding: utf-8

"""
    Acre Platform User API

    # CORS CORS is implemented by all Acre API endpoints and only certain hostnames are allowed for each deployment of the API. If your use case requires calling the Acre User API from a browser, please contact Acre to arrange the appropriate configuration. # API Authentication The primary method of authentication for users of the Acre API is with the use of JSON Web Tokens (JWTs), which are suplemented by an application specific API Key. The API key must be provided through the `X-API-KEY` HTTP header and will be provided by your Acre Customer Success Manager. The JWT must be provided through a cookie with key of `authorization`. The JWT must be generated and signed as per the following section. # Generating JWTs JWT must either be generated by a third-party such as Azure ADB2C that has been configured for the appropriate service and/or user account, or alternatively can be generated locally and signed by an private key for which the public key has been made available to Acre via a JWKS URL. In addition to being signed by your private key, the JWT will also need to contain at a minimum:  * An issuer `iss`, which must be a valid URI previously agreed with Acre.  * A subject `sub`, which must be a unique identifier for the user and/or service account previously agreed with Acre.  * An expiry time `exp` which must not be more than four hours in the future.  * A not before time `nbf` which must be in the past, but not greater than six hours in the past.  The JWT should be signed using RS256.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class CdmOrigoCodes(str, Enum):
    """
    CdmOrigoCodes
    """

    """
    allowed enum values
    """
    INVALID_ORIGO_CODE = 'INVALID_ORIGO_CODE'
    AAB00001 = 'AAB00001'
    AAC02588 = 'AAC02588'
    AAD03000 = 'AAD03000'
    AAB00010 = 'AAB00010'
    AAB00011 = 'AAB00011'
    AAD03001 = 'AAD03001'
    AAB00013 = 'AAB00013'
    AAD03002 = 'AAD03002'
    AAB00020 = 'AAB00020'
    AAB00021 = 'AAB00021'
    AAB00022 = 'AAB00022'
    AAC02590 = 'AAC02590'
    AAD03003 = 'AAD03003'
    AAB00023 = 'AAB00023'
    AAC02591 = 'AAC02591'
    AAB00024 = 'AAB00024'
    AAB00025 = 'AAB00025'
    AAB00026 = 'AAB00026'
    AAC02592 = 'AAC02592'
    AAB00027 = 'AAB00027'
    AAB00028 = 'AAB00028'
    AAB00030 = 'AAB00030'
    AAB00031 = 'AAB00031'
    AAD03004 = 'AAD03004'
    AAB00036 = 'AAB00036'
    AAB00037 = 'AAB00037'
    AAB00038 = 'AAB00038'
    AAB00039 = 'AAB00039'
    AAB00041 = 'AAB00041'
    AAC02593 = 'AAC02593'
    AAB00042 = 'AAB00042'
    AAB00043 = 'AAB00043'
    AAB00044 = 'AAB00044'
    AAB00045 = 'AAB00045'
    AAB00046 = 'AAB00046'
    AAB00047 = 'AAB00047'
    AAB00048 = 'AAB00048'
    AAB00049 = 'AAB00049'
    AAB00050 = 'AAB00050'
    AAB00051 = 'AAB00051'
    AAB00052 = 'AAB00052'
    AAB00053 = 'AAB00053'
    AAB00054 = 'AAB00054'
    AAB00055 = 'AAB00055'
    AAD03392 = 'AAD03392'
    AAC02594 = 'AAC02594'
    AAB00057 = 'AAB00057'
    AAB00058 = 'AAB00058'
    AAB00119 = 'AAB00119'
    AAD03005 = 'AAD03005'
    AAB00060 = 'AAB00060'
    AAD03006 = 'AAD03006'
    AAD03007 = 'AAD03007'
    AAD03008 = 'AAD03008'
    AAD03009 = 'AAD03009'
    AAD03010 = 'AAD03010'
    AAC02596 = 'AAC02596'
    AAB00062 = 'AAB00062'
    AAB00063 = 'AAB00063'
    AAB00064 = 'AAB00064'
    AAB00065 = 'AAB00065'
    AAB00066 = 'AAB00066'
    AAB00067 = 'AAB00067'
    AAB00068 = 'AAB00068'
    AAB00069 = 'AAB00069'
    AAB00070 = 'AAB00070'
    AAB00071 = 'AAB00071'
    AAB00073 = 'AAB00073'
    AAB00074 = 'AAB00074'
    AAC02597 = 'AAC02597'
    AAB00075 = 'AAB00075'
    AAC02598 = 'AAC02598'
    AAB00076 = 'AAB00076'
    AAD03014 = 'AAD03014'
    AAD03011 = 'AAD03011'
    AAD03012 = 'AAD03012'
    AAD03013 = 'AAD03013'
    AAD03015 = 'AAD03015'
    AAD03016 = 'AAD03016'
    AAD03019 = 'AAD03019'
    AAD03017 = 'AAD03017'
    AAD3390 = 'AAD3390'
    AAD03018 = 'AAD03018'
    AAD03389 = 'AAD03389'
    AAD03020 = 'AAD03020'
    AAB00079 = 'AAB00079'
    AAB00080 = 'AAB00080'
    AAB00081 = 'AAB00081'
    AAB00082 = 'AAB00082'
    AAB00083 = 'AAB00083'
    AAB00084 = 'AAB00084'
    AAC02599 = 'AAC02599'
    AAB00085 = 'AAB00085'
    AAB00086 = 'AAB00086'
    AAB00087 = 'AAB00087'
    AAB00088 = 'AAB00088'
    AAD03021 = 'AAD03021'
    AAB00089 = 'AAB00089'
    AAB00095 = 'AAB00095'
    AAB00108 = 'AAB00108'
    AAB00109 = 'AAB00109'
    AAC02600 = 'AAC02600'
    AAB00110 = 'AAB00110'
    AAB00111 = 'AAB00111'
    AAB00112 = 'AAB00112'
    AAB00113 = 'AAB00113'
    AAB00114 = 'AAB00114'
    AAB00115 = 'AAB00115'
    AAC02601 = 'AAC02601'
    AAB00116 = 'AAB00116'
    AAB00117 = 'AAB00117'
    AAC02602 = 'AAC02602'
    AAB00120 = 'AAB00120'
    AAB00121 = 'AAB00121'
    AAD03022 = 'AAD03022'
    AAB00122 = 'AAB00122'
    AAB00123 = 'AAB00123'
    AAB00124 = 'AAB00124'
    AAB00125 = 'AAB00125'
    AAB00126 = 'AAB00126'
    AAB00127 = 'AAB00127'
    AAB00128 = 'AAB00128'
    AAD03023 = 'AAD03023'
    BAB00130 = 'BAB00130'
    BAD03025 = 'BAD03025'
    BAB00133 = 'BAB00133'
    BAB00134 = 'BAB00134'
    BAD03026 = 'BAD03026'
    BAC02606 = 'BAC02606'
    BAB00135 = 'BAB00135'
    BAC02607 = 'BAC02607'
    BAB00137 = 'BAB00137'
    BAB00138 = 'BAB00138'
    BAB00139 = 'BAB00139'
    BAB00141 = 'BAB00141'
    BAD03027 = 'BAD03027'
    BAB00152 = 'BAB00152'
    BAC02609 = 'BAC02609'
    BAB00153 = 'BAB00153'
    BAC02610 = 'BAC02610'
    BAC02611 = 'BAC02611'
    BAB00154 = 'BAB00154'
    BAB00155 = 'BAB00155'
    BAB00156 = 'BAB00156'
    BAB00157 = 'BAB00157'
    BAB00158 = 'BAB00158'
    BAB00159 = 'BAB00159'
    BAB00160 = 'BAB00160'
    BAC02612 = 'BAC02612'
    BAB00161 = 'BAB00161'
    BAB00163 = 'BAB00163'
    BAB00164 = 'BAB00164'
    BAB00165 = 'BAB00165'
    BAB00167 = 'BAB00167'
    BAC02613 = 'BAC02613'
    BAC02614 = 'BAC02614'
    BAB00168 = 'BAB00168'
    BAB00169 = 'BAB00169'
    BAB00170 = 'BAB00170'
    BAB00171 = 'BAB00171'
    BAB00172 = 'BAB00172'
    BAB00173 = 'BAB00173'
    BAC02615 = 'BAC02615'
    BAC02616 = 'BAC02616'
    BAB00174 = 'BAB00174'
    BAD03029 = 'BAD03029'
    BAB00176 = 'BAB00176'
    BAB00177 = 'BAB00177'
    BAD03030 = 'BAD03030'
    BAC02618 = 'BAC02618'
    BAC02619 = 'BAC02619'
    BAC02620 = 'BAC02620'
    BAB00178 = 'BAB00178'
    BAB00179 = 'BAB00179'
    BAB00180 = 'BAB00180'
    BAB00181 = 'BAB00181'
    BAB00182 = 'BAB00182'
    BAB00183 = 'BAB00183'
    BAD03031 = 'BAD03031'
    BAB00184 = 'BAB00184'
    BAB00185 = 'BAB00185'
    BAB00186 = 'BAB00186'
    BAB00187 = 'BAB00187'
    BAB00188 = 'BAB00188'
    BAB00189 = 'BAB00189'
    BAB00190 = 'BAB00190'
    BAB00191 = 'BAB00191'
    BAB00192 = 'BAB00192'
    BAB00193 = 'BAB00193'
    BAB00194 = 'BAB00194'
    BAB00195 = 'BAB00195'
    BAB00196 = 'BAB00196'
    BAB00197 = 'BAB00197'
    BAB00198 = 'BAB00198'
    BAB00199 = 'BAB00199'
    BAB00200 = 'BAB00200'
    BAB00201 = 'BAB00201'
    BAB00202 = 'BAB00202'
    BAB00203 = 'BAB00203'
    BAD03032 = 'BAD03032'
    BAB00204 = 'BAB00204'
    BAB00205 = 'BAB00205'
    BAB00206 = 'BAB00206'
    BAB00207 = 'BAB00207'
    BAB00208 = 'BAB00208'
    BAB00209 = 'BAB00209'
    BAB00210 = 'BAB00210'
    BAB00212 = 'BAB00212'
    BAB00211 = 'BAB00211'
    BAB00213 = 'BAB00213'
    BAB00214 = 'BAB00214'
    BAB00215 = 'BAB00215'
    BAB00216 = 'BAB00216'
    BAB00217 = 'BAB00217'
    BAB00218 = 'BAB00218'
    BAD03033 = 'BAD03033'
    BAD03034 = 'BAD03034'
    BAB00224 = 'BAB00224'
    BAB00226 = 'BAB00226'
    BAB00227 = 'BAB00227'
    BAB00228 = 'BAB00228'
    BAB00229 = 'BAB00229'
    BAD03035 = 'BAD03035'
    BAB00230 = 'BAB00230'
    BAB00231 = 'BAB00231'
    BAB00232 = 'BAB00232'
    BAB00233 = 'BAB00233'
    BAD03036 = 'BAD03036'
    BAD03037 = 'BAD03037'
    BAD03038 = 'BAD03038'
    BAD03039 = 'BAD03039'
    BAD03388 = 'BAD03388'
    BAD03040 = 'BAD03040'
    BAB00236 = 'BAB00236'
    BAB00237 = 'BAB00237'
    BAB00238 = 'BAB00238'
    BAC02621 = 'BAC02621'
    BAB00239 = 'BAB00239'
    BAC02623 = 'BAC02623'
    BAD03041 = 'BAD03041'
    BAB00241 = 'BAB00241'
    BAB00243 = 'BAB00243'
    BAD03042 = 'BAD03042'
    BAC02625 = 'BAC02625'
    BAB00250 = 'BAB00250'
    BAB00251 = 'BAB00251'
    BAB00252 = 'BAB00252'
    BAB00253 = 'BAB00253'
    BAB00255 = 'BAB00255'
    BAC02627 = 'BAC02627'
    BAB00256 = 'BAB00256'
    BAB00257 = 'BAB00257'
    BAB00258 = 'BAB00258'
    BAC02628 = 'BAC02628'
    BAD03044 = 'BAD03044'
    CAD03055 = 'CAD03055'
    CAD03056 = 'CAD03056'
    CAB00259 = 'CAB00259'
    CAB00260 = 'CAB00260'
    CAB00261 = 'CAB00261'
    CAB00262 = 'CAB00262'
    CAB00263 = 'CAB00263'
    CAB00264 = 'CAB00264'
    CAB00265 = 'CAB00265'
    CAB00266 = 'CAB00266'
    CAC02629 = 'CAC02629'
    CAB00267 = 'CAB00267'
    CAB00268 = 'CAB00268'
    CAD03046 = 'CAD03046'
    CAB00270 = 'CAB00270'
    CAD03047 = 'CAD03047'
    CAD03048 = 'CAD03048'
    CAB00271 = 'CAB00271'
    CAC02630 = 'CAC02630'
    CAC02631 = 'CAC02631'
    CAD03049 = 'CAD03049'
    CAB00273 = 'CAB00273'
    CAD03050 = 'CAD03050'
    CAB00275 = 'CAB00275'
    CAB00276 = 'CAB00276'
    CAC02632 = 'CAC02632'
    CAB00277 = 'CAB00277'
    CAB00278 = 'CAB00278'
    CAB00279 = 'CAB00279'
    CAB00280 = 'CAB00280'
    CAB00282 = 'CAB00282'
    CAB00281 = 'CAB00281'
    CAB00284 = 'CAB00284'
    CAC02633 = 'CAC02633'
    CAB00285 = 'CAB00285'
    CAB00286 = 'CAB00286'
    CAC02634 = 'CAC02634'
    CAD03051 = 'CAD03051'
    CAB00287 = 'CAB00287'
    CAB00288 = 'CAB00288'
    CAB00289 = 'CAB00289'
    CAB00306 = 'CAB00306'
    CAD03052 = 'CAD03052'
    CAD03053 = 'CAD03053'
    CAB00290 = 'CAB00290'
    CAB00291 = 'CAB00291'
    CAB00292 = 'CAB00292'
    CAB00293 = 'CAB00293'
    CAC02635 = 'CAC02635'
    CAC02636 = 'CAC02636'
    CAB00294 = 'CAB00294'
    CAB00295 = 'CAB00295'
    CAB00296 = 'CAB00296'
    CAB00299 = 'CAB00299'
    CAB00297 = 'CAB00297'
    CAB00298 = 'CAB00298'
    CAC02637 = 'CAC02637'
    CAC02638 = 'CAC02638'
    CAC02639 = 'CAC02639'
    CAB00300 = 'CAB00300'
    CAC02640 = 'CAC02640'
    CAC02642 = 'CAC02642'
    CAC02643 = 'CAC02643'
    CAC02644 = 'CAC02644'
    CAB00302 = 'CAB00302'
    CAB00301 = 'CAB00301'
    CAB00303 = 'CAB00303'
    CAB00304 = 'CAB00304'
    CAB00305 = 'CAB00305'
    CAC02645 = 'CAC02645'
    CAC02646 = 'CAC02646'
    CAB00309 = 'CAB00309'
    CAB00310 = 'CAB00310'
    CAB00311 = 'CAB00311'
    CAB00312 = 'CAB00312'
    CAC02647 = 'CAC02647'
    CAC02648 = 'CAC02648'
    CAC02649 = 'CAC02649'
    CAB00317 = 'CAB00317'
    CAD03054 = 'CAD03054'
    CAB00323 = 'CAB00323'
    CAB00324 = 'CAB00324'
    CAB00325 = 'CAB00325'
    CAD03057 = 'CAD03057'
    CAB00326 = 'CAB00326'
    CAB00328 = 'CAB00328'
    CAB00329 = 'CAB00329'
    CAC02653 = 'CAC02653'
    CAB00330 = 'CAB00330'
    CAD03058 = 'CAD03058'
    CAD03390 = 'CAD03390'
    CAD03391 = 'CAD03391'
    CAC02654 = 'CAC02654'
    CAC02655 = 'CAC02655'
    CAC02656 = 'CAC02656'
    CAC02657 = 'CAC02657'
    CAB00332 = 'CAB00332'
    CAB00333 = 'CAB00333'
    CAB00336 = 'CAB00336'
    CAB00344 = 'CAB00344'
    CAB00345 = 'CAB00345'
    CAD03059 = 'CAD03059'
    CAB00340 = 'CAB00340'
    CAD03060 = 'CAD03060'
    CAD03061 = 'CAD03061'
    CAC02658 = 'CAC02658'
    CAD03062 = 'CAD03062'
    CAC02659 = 'CAC02659'
    CAB00368 = 'CAB00368'
    CAB00370 = 'CAB00370'
    CAB00371 = 'CAB00371'
    CAC02660 = 'CAC02660'
    CAC02661 = 'CAC02661'
    CAB00372 = 'CAB00372'
    CAC02662 = 'CAC02662'
    CAD03063 = 'CAD03063'
    CAB00373 = 'CAB00373'
    CAB00374 = 'CAB00374'
    CAB00375 = 'CAB00375'
    CAB00376 = 'CAB00376'
    CAB00377 = 'CAB00377'
    CAB00378 = 'CAB00378'
    CAC02664 = 'CAC02664'
    CAD03064 = 'CAD03064'
    CAB00383 = 'CAB00383'
    CAD03065 = 'CAD03065'
    CAD03066 = 'CAD03066'
    CAD03067 = 'CAD03067'
    CAB00390 = 'CAB00390'
    CAB00391 = 'CAB00391'
    CAD03068 = 'CAD03068'
    CAC02666 = 'CAC02666'
    CAD03069 = 'CAD03069'
    CAB00405 = 'CAB00405'
    CAB00406 = 'CAB00406'
    CAB00407 = 'CAB00407'
    CAB00409 = 'CAB00409'
    CAB00412 = 'CAB00412'
    CAB00413 = 'CAB00413'
    CAB00414 = 'CAB00414'
    CAB00415 = 'CAB00415'
    CAB00416 = 'CAB00416'
    CAB00417 = 'CAB00417'
    CAC02671 = 'CAC02671'
    CAB00418 = 'CAB00418'
    CAB00419 = 'CAB00419'
    CAB00420 = 'CAB00420'
    CAB00421 = 'CAB00421'
    CAD03070 = 'CAD03070'
    CAB00427 = 'CAB00427'
    CAB00428 = 'CAB00428'
    CAB00431 = 'CAB00431'
    CAB00432 = 'CAB00432'
    CAB00433 = 'CAB00433'
    CAB00434 = 'CAB00434'
    CAB00435 = 'CAB00435'
    CAB00436 = 'CAB00436'
    CAB00437 = 'CAB00437'
    CAB00438 = 'CAB00438'
    CAB00439 = 'CAB00439'
    CAB00440 = 'CAB00440'
    CAB00441 = 'CAB00441'
    CAB00442 = 'CAB00442'
    CAB00443 = 'CAB00443'
    CAB00444 = 'CAB00444'
    CAB00445 = 'CAB00445'
    CAB00446 = 'CAB00446'
    CAB00447 = 'CAB00447'
    CAB00449 = 'CAB00449'
    CAB00450 = 'CAB00450'
    CAB00451 = 'CAB00451'
    CAB00452 = 'CAB00452'
    CAB00453 = 'CAB00453'
    CAB00454 = 'CAB00454'
    CAB00455 = 'CAB00455'
    CAB00456 = 'CAB00456'
    CAC02674 = 'CAC02674'
    CAB00457 = 'CAB00457'
    CAC02675 = 'CAC02675'
    CAB00458 = 'CAB00458'
    CAD03071 = 'CAD03071'
    CAB00460 = 'CAB00460'
    CAC02678 = 'CAC02678'
    CAC02679 = 'CAC02679'
    CAB00462 = 'CAB00462'
    CAC02680 = 'CAC02680'
    CAB00463 = 'CAB00463'
    CAB00464 = 'CAB00464'
    CAB00465 = 'CAB00465'
    CAC02681 = 'CAC02681'
    CAC02682 = 'CAC02682'
    CAB00466 = 'CAB00466'
    CAC02683 = 'CAC02683'
    CAB00467 = 'CAB00467'
    CAC02684 = 'CAC02684'
    CAC02685 = 'CAC02685'
    CAC02686 = 'CAC02686'
    CAC02687 = 'CAC02687'
    CAC02688 = 'CAC02688'
    CAC02689 = 'CAC02689'
    CAC02690 = 'CAC02690'
    CAB00468 = 'CAB00468'
    CAB00469 = 'CAB00469'
    CAB00470 = 'CAB00470'
    CAB00471 = 'CAB00471'
    CAB00472 = 'CAB00472'
    CAB00473 = 'CAB00473'
    CAB00474 = 'CAB00474'
    CAB00475 = 'CAB00475'
    CAC02691 = 'CAC02691'
    CAC02692 = 'CAC02692'
    CAC02693 = 'CAC02693'
    CAB00476 = 'CAB00476'
    CAB00478 = 'CAB00478'
    CAB00480 = 'CAB00480'
    CAB00481 = 'CAB00481'
    CAB00482 = 'CAB00482'
    CAD03072 = 'CAD03072'
    CAD03073 = 'CAD03073'
    CAD03074 = 'CAD03074'
    CAB00508 = 'CAB00508'
    CAB00514 = 'CAB00514'
    CAB00515 = 'CAB00515'
    CAB00516 = 'CAB00516'
    CAB00517 = 'CAB00517'
    CAB00518 = 'CAB00518'
    CAC02695 = 'CAC02695'
    CAB00519 = 'CAB00519'
    CAB00520 = 'CAB00520'
    CAB00521 = 'CAB00521'
    CAB00522 = 'CAB00522'
    CAB00524 = 'CAB00524'
    CAB00523 = 'CAB00523'
    CAB00526 = 'CAB00526'
    CAB00525 = 'CAB00525'
    CAB00527 = 'CAB00527'
    CAB00528 = 'CAB00528'
    CAC02696 = 'CAC02696'
    CAB00529 = 'CAB00529'
    CAB00530 = 'CAB00530'
    CAB00531 = 'CAB00531'
    CAB00532 = 'CAB00532'
    CAC02697 = 'CAC02697'
    CAB00533 = 'CAB00533'
    CAB00534 = 'CAB00534'
    CAB00535 = 'CAB00535'
    CAB00542 = 'CAB00542'
    CAD03075 = 'CAD03075'
    CAD03076 = 'CAD03076'
    CAC02698 = 'CAC02698'
    CAC02699 = 'CAC02699'
    CAB00559 = 'CAB00559'
    CAD03077 = 'CAD03077'
    CAD03078 = 'CAD03078'
    CAB00562 = 'CAB00562'
    CAB00563 = 'CAB00563'
    CAB00566 = 'CAB00566'
    CAC02700 = 'CAC02700'
    CAB00567 = 'CAB00567'
    CAB00568 = 'CAB00568'
    CAC02701 = 'CAC02701'
    CAD03079 = 'CAD03079'
    CAD03080 = 'CAD03080'
    CAD03081 = 'CAD03081'
    CAD03082 = 'CAD03082'
    DAC02702 = 'DAC02702'
    DAB00582 = 'DAB00582'
    DAC02703 = 'DAC02703'
    DAD03084 = 'DAD03084'
    DAD03085 = 'DAD03085'
    DAD03086 = 'DAD03086'
    DAB00585 = 'DAB00585'
    DAB00586 = 'DAB00586'
    DAB00587 = 'DAB00587'
    DAB00589 = 'DAB00589'
    DAC02706 = 'DAC02706'
    DAB00593 = 'DAB00593'
    DAB00594 = 'DAB00594'
    DAB00595 = 'DAB00595'
    DAD03087 = 'DAD03087'
    DAB00598 = 'DAB00598'
    DAC02707 = 'DAC02707'
    DAB00599 = 'DAB00599'
    DAB00600 = 'DAB00600'
    DAB00601 = 'DAB00601'
    DAB00602 = 'DAB00602'
    DAD03088 = 'DAD03088'
    DAB00603 = 'DAB00603'
    DAB00604 = 'DAB00604'
    DAB00605 = 'DAB00605'
    DAD03089 = 'DAD03089'
    DAD03090 = 'DAD03090'
    DAC02708 = 'DAC02708'
    DAD03091 = 'DAD03091'
    DAB00612 = 'DAB00612'
    DAB00616 = 'DAB00616'
    DAD03092 = 'DAD03092'
    DAB00626 = 'DAB00626'
    DAB00627 = 'DAB00627'
    DAB00629 = 'DAB00629'
    DAC02709 = 'DAC02709'
    DAB00631 = 'DAB00631'
    DAD03093 = 'DAD03093'
    DAD03375 = 'DAD03375'
    DAD03376 = 'DAD03376'
    DAD03377 = 'DAD03377'
    DAD03378 = 'DAD03378'
    DAD03379 = 'DAD03379'
    DAD03380 = 'DAD03380'
    DAD03381 = 'DAD03381'
    DAD03386 = 'DAD03386'
    FAC02771 = 'FAC02771'
    DAC02710 = 'DAC02710'
    DAB00637 = 'DAB00637'
    DAB00638 = 'DAB00638'
    DAB00639 = 'DAB00639'
    DAC02711 = 'DAC02711'
    DAB00640 = 'DAB00640'
    DAC02712 = 'DAC02712'
    DAB00641 = 'DAB00641'
    DAB00642 = 'DAB00642'
    DAC02713 = 'DAC02713'
    DAC02714 = 'DAC02714'
    DAB00643 = 'DAB00643'
    DAB00644 = 'DAB00644'
    DAB00647 = 'DAB00647'
    DAB00648 = 'DAB00648'
    DAB00649 = 'DAB00649'
    DAB00650 = 'DAB00650'
    DAB00651 = 'DAB00651'
    DAB00652 = 'DAB00652'
    DAC02715 = 'DAC02715'
    DAB00655 = 'DAB00655'
    DAB00656 = 'DAB00656'
    DAB00657 = 'DAB00657'
    DAB00658 = 'DAB00658'
    DAC02716 = 'DAC02716'
    DAB00659 = 'DAB00659'
    DAB00660 = 'DAB00660'
    DAD03094 = 'DAD03094'
    DAC02717 = 'DAC02717'
    DAC02719 = 'DAC02719'
    DAD03095 = 'DAD03095'
    DAC02720 = 'DAC02720'
    DAB00665 = 'DAB00665'
    DAB00666 = 'DAB00666'
    DAB00667 = 'DAB00667'
    DAB00668 = 'DAB00668'
    DAB00669 = 'DAB00669'
    DAB00672 = 'DAB00672'
    DAB00673 = 'DAB00673'
    DAD03096 = 'DAD03096'
    DAD03097 = 'DAD03097'
    DAD03098 = 'DAD03098'
    DAD03101 = 'DAD03101'
    DAD03103 = 'DAD03103'
    DAD03099 = 'DAD03099'
    DAD03100 = 'DAD03100'
    DAD03102 = 'DAD03102'
    DAC02724 = 'DAC02724'
    DAC02725 = 'DAC02725'
    DAB00699 = 'DAB00699'
    DAB00700 = 'DAB00700'
    DAB00701 = 'DAB00701'
    DAB00702 = 'DAB00702'
    DAB00703 = 'DAB00703'
    DAB00708 = 'DAB00708'
    DAB00710 = 'DAB00710'
    EAD03104 = 'EAD03104'
    EAD03105 = 'EAD03105'
    EAB00712 = 'EAB00712'
    EAD03106 = 'EAD03106'
    EAD03107 = 'EAD03107'
    EAD03108 = 'EAD03108'
    EAC02729 = 'EAC02729'
    EAB00715 = 'EAB00715'
    EAB00716 = 'EAB00716'
    EAB00717 = 'EAB00717'
    EAD03109 = 'EAD03109'
    EAB00722 = 'EAB00722'
    EAB00724 = 'EAB00724'
    EAD03110 = 'EAD03110'
    EAD03111 = 'EAD03111'
    EAD03112 = 'EAD03112'
    EAB00736 = 'EAB00736'
    EAB00737 = 'EAB00737'
    EAB00738 = 'EAB00738'
    EAB00739 = 'EAB00739'
    EAB00740 = 'EAB00740'
    EAB00741 = 'EAB00741'
    EAB00742 = 'EAB00742'
    EAB00743 = 'EAB00743'
    EAB00744 = 'EAB00744'
    EAD03113 = 'EAD03113'
    EAB00745 = 'EAB00745'
    EAC02740 = 'EAC02740'
    EAD03114 = 'EAD03114'
    EAB00746 = 'EAB00746'
    EAB00747 = 'EAB00747'
    EAB00748 = 'EAB00748'
    EAD03115 = 'EAD03115'
    EAD03116 = 'EAD03116'
    EAD03117 = 'EAD03117'
    EAD03118 = 'EAD03118'
    EAC02742 = 'EAC02742'
    EAD03120 = 'EAD03120'
    EAD03121 = 'EAD03121'
    EAB00762 = 'EAB00762'
    EAB00764 = 'EAB00764'
    EAD03122 = 'EAD03122'
    EAB00770 = 'EAB00770'
    EAC02746 = 'EAC02746'
    EAC02747 = 'EAC02747'
    EAC02748 = 'EAC02748'
    EAB00771 = 'EAB00771'
    EAC02749 = 'EAC02749'
    EAB00772 = 'EAB00772'
    EAB00773 = 'EAB00773'
    EAB00774 = 'EAB00774'
    EAB00775 = 'EAB00775'
    EAB00776 = 'EAB00776'
    EAB00777 = 'EAB00777'
    EAB00778 = 'EAB00778'
    EAB00779 = 'EAB00779'
    EAC02750 = 'EAC02750'
    EAB00780 = 'EAB00780'
    EAB00781 = 'EAB00781'
    EAC02751 = 'EAC02751'
    EAB00785 = 'EAB00785'
    EAB00783 = 'EAB00783'
    EAB00782 = 'EAB00782'
    EAB00784 = 'EAB00784'
    EAD03124 = 'EAD03124'
    EAB00795 = 'EAB00795'
    EAD03125 = 'EAD03125'
    EAB00796 = 'EAB00796'
    EAC02752 = 'EAC02752'
    EAC02753 = 'EAC02753'
    EAB00797 = 'EAB00797'
    EAB00798 = 'EAB00798'
    EAC02754 = 'EAC02754'
    EAB00800 = 'EAB00800'
    FAD03126 = 'FAD03126'
    FAD03127 = 'FAD03127'
    FAD03128 = 'FAD03128'
    FAB00803 = 'FAB00803'
    FAB00806 = 'FAB00806'
    FAC02755 = 'FAC02755'
    FAC02756 = 'FAC02756'
    FAC02757 = 'FAC02757'
    FAC02760 = 'FAC02760'
    FAC02761 = 'FAC02761'
    FAC02762 = 'FAC02762'
    FAC02763 = 'FAC02763'
    FAC02764 = 'FAC02764'
    FAB00811 = 'FAB00811'
    FAB00812 = 'FAB00812'
    FAB00813 = 'FAB00813'
    FAD03129 = 'FAD03129'
    FAD03130 = 'FAD03130'
    FAC02767 = 'FAC02767'
    FAB00814 = 'FAB00814'
    FAC02768 = 'FAC02768'
    FAB00816 = 'FAB00816'
    FAB00821 = 'FAB00821'
    FAB00823 = 'FAB00823'
    FAB00824 = 'FAB00824'
    FAB00825 = 'FAB00825'
    FAB00827 = 'FAB00827'
    FAC02774 = 'FAC02774'
    FAD03131 = 'FAD03131'
    FAD03132 = 'FAD03132'
    FAB00832 = 'FAB00832'
    FAB00833 = 'FAB00833'
    FAB00835 = 'FAB00835'
    FAB00843 = 'FAB00843'
    FAB00848 = 'FAB00848'
    FAD03133 = 'FAD03133'
    FAD03134 = 'FAD03134'
    FAB00849 = 'FAB00849'
    FAB00850 = 'FAB00850'
    FAC02779 = 'FAC02779'
    FAC02782 = 'FAC02782'
    FAB00852 = 'FAB00852'
    FAB00855 = 'FAB00855'
    FAB00858 = 'FAB00858'
    FAB00864 = 'FAB00864'
    FAB00865 = 'FAB00865'
    FAD03135 = 'FAD03135'
    FAB00867 = 'FAB00867'
    FAD03138 = 'FAD03138'
    FAB00869 = 'FAB00869'
    FAB00870 = 'FAB00870'
    FAB00871 = 'FAB00871'
    FAB00872 = 'FAB00872'
    FAB00873 = 'FAB00873'
    FAC02785 = 'FAC02785'
    FAC02786 = 'FAC02786'
    FAB00874 = 'FAB00874'
    FAB00876 = 'FAB00876'
    FAC02787 = 'FAC02787'
    FAC02788 = 'FAC02788'
    FAD03139 = 'FAD03139'
    FAD03140 = 'FAD03140'
    FAD03141 = 'FAD03141'
    FAD03142 = 'FAD03142'
    FAD03143 = 'FAD03143'
    FAB00937 = 'FAB00937'
    FAB00938 = 'FAB00938'
    FAB00940 = 'FAB00940'
    FAB00941 = 'FAB00941'
    FAB00942 = 'FAB00942'
    FAB00943 = 'FAB00943'
    FAB00944 = 'FAB00944'
    FAB00945 = 'FAB00945'
    FAD03136 = 'FAD03136'
    FAB00946 = 'FAB00946'
    FAB00947 = 'FAB00947'
    FAB00948 = 'FAB00948'
    FAB00949 = 'FAB00949'
    FAB00950 = 'FAB00950'
    FAB00951 = 'FAB00951'
    FAC02793 = 'FAC02793'
    FAB00952 = 'FAB00952'
    FAB00953 = 'FAB00953'
    FAB00954 = 'FAB00954'
    FAB00955 = 'FAB00955'
    FAB00956 = 'FAB00956'
    FAD03137 = 'FAD03137'
    FAB00961 = 'FAB00961'
    FAC02794 = 'FAC02794'
    FAB00962 = 'FAB00962'
    FAC02795 = 'FAC02795'
    FAC02796 = 'FAC02796'
    GAD03146 = 'GAD03146'
    GAD03150 = 'GAD03150'
    GAC02797 = 'GAC02797'
    GAC02798 = 'GAC02798'
    GAD03155 = 'GAD03155'
    GAB00965 = 'GAB00965'
    GAB00966 = 'GAB00966'
    GAB00968 = 'GAB00968'
    GAD03156 = 'GAD03156'
    GAC02800 = 'GAC02800'
    GAC02801 = 'GAC02801'
    GAC02802 = 'GAC02802'
    GAC02803 = 'GAC02803'
    GAC02804 = 'GAC02804'
    GAB00971 = 'GAB00971'
    GAB00972 = 'GAB00972'
    GAB00976 = 'GAB00976'
    GAB00979 = 'GAB00979'
    GAB00984 = 'GAB00984'
    GAB00985 = 'GAB00985'
    GAB00986 = 'GAB00986'
    GAB00987 = 'GAB00987'
    GAB00988 = 'GAB00988'
    GAB00989 = 'GAB00989'
    GAB00990 = 'GAB00990'
    GAB00991 = 'GAB00991'
    GAD03145 = 'GAD03145'
    GAC02806 = 'GAC02806'
    GAD03151 = 'GAD03151'
    GAB00996 = 'GAB00996'
    GAD03152 = 'GAD03152'
    GAB01000 = 'GAB01000'
    GAC02807 = 'GAC02807'
    GAB01001 = 'GAB01001'
    GAB01003 = 'GAB01003'
    GAB01004 = 'GAB01004'
    GAC02808 = 'GAC02808'
    GAC02809 = 'GAC02809'
    GAB01007 = 'GAB01007'
    GAD03154 = 'GAD03154'
    GAB01010 = 'GAB01010'
    GAD03144 = 'GAD03144'
    GAC02813 = 'GAC02813'
    GAB01019 = 'GAB01019'
    GAB01020 = 'GAB01020'
    GAB01021 = 'GAB01021'
    GAB01022 = 'GAB01022'
    GAB01023 = 'GAB01023'
    GAD03147 = 'GAD03147'
    GAD03148 = 'GAD03148'
    GAD03149 = 'GAD03149'
    GAC02815 = 'GAC02815'
    GAC02816 = 'GAC02816'
    GAB01025 = 'GAB01025'
    GAB01026 = 'GAB01026'
    GAD03153 = 'GAD03153'
    HAC02817 = 'HAC02817'
    HAB01028 = 'HAB01028'
    HAB01029 = 'HAB01029'
    HAC02818 = 'HAC02818'
    HAC02819 = 'HAC02819'
    HAD03164 = 'HAD03164'
    HAB01037 = 'HAB01037'
    HAB01038 = 'HAB01038'
    HAC02820 = 'HAC02820'
    HAD03157 = 'HAD03157'
    HAB01041 = 'HAB01041'
    HAB01043 = 'HAB01043'
    HAB01044 = 'HAB01044'
    HAC02822 = 'HAC02822'
    HAB01046 = 'HAB01046'
    HAB01047 = 'HAB01047'
    HAB01048 = 'HAB01048'
    HAB01049 = 'HAB01049'
    HAB01050 = 'HAB01050'
    HAC02823 = 'HAC02823'
    HAC02824 = 'HAC02824'
    HAC02827 = 'HAC02827'
    HAB01053 = 'HAB01053'
    HAC02828 = 'HAC02828'
    HAC02825 = 'HAC02825'
    HAC02826 = 'HAC02826'
    HAC02829 = 'HAC02829'
    HAC02830 = 'HAC02830'
    HAB01064 = 'HAB01064'
    HAC02831 = 'HAC02831'
    HAC02832 = 'HAC02832'
    HAC02833 = 'HAC02833'
    HAB01066 = 'HAB01066'
    HAD03162 = 'HAD03162'
    HAB01067 = 'HAB01067'
    HAD03163 = 'HAD03163'
    HAD03165 = 'HAD03165'
    HAC02834 = 'HAC02834'
    HAC02835 = 'HAC02835'
    HAC02836 = 'HAC02836'
    HAB01076 = 'HAB01076'
    HAB01077 = 'HAB01077'
    HAB01078 = 'HAB01078'
    HAC02837 = 'HAC02837'
    HAB01082 = 'HAB01082'
    HAB01084 = 'HAB01084'
    HAB01085 = 'HAB01085'
    HAB01086 = 'HAB01086'
    HAB01087 = 'HAB01087'
    HAB01088 = 'HAB01088'
    HAB01089 = 'HAB01089'
    HAD03166 = 'HAD03166'
    HAB01090 = 'HAB01090'
    HAB01091 = 'HAB01091'
    HAB01092 = 'HAB01092'
    HAC02838 = 'HAC02838'
    HAB01094 = 'HAB01094'
    HAB01095 = 'HAB01095'
    HAB01096 = 'HAB01096'
    HAB01097 = 'HAB01097'
    HAB01098 = 'HAB01098'
    HAB01099 = 'HAB01099'
    HAC02839 = 'HAC02839'
    HAB01100 = 'HAB01100'
    HAC02840 = 'HAC02840'
    HAD03158 = 'HAD03158'
    HAD03159 = 'HAD03159'
    HAD03161 = 'HAD03161'
    HAD03386 = 'HAD03386'
    HAD03387 = 'HAD03387'
    HAD03160 = 'HAD03160'
    HAC02841 = 'HAC02841'
    HAC02842 = 'HAC02842'
    HAB01104 = 'HAB01104'
    HAB01105 = 'HAB01105'
    IAD03170 = 'IAD03170'
    IAD03172 = 'IAD03172'
    IAD03174 = 'IAD03174'
    IAD03176 = 'IAD03176'
    IAB01106 = 'IAB01106'
    IAB01110 = 'IAB01110'
    IAC02846 = 'IAC02846'
    IAD03175 = 'IAD03175'
    IAD03177 = 'IAD03177'
    IAB01111 = 'IAB01111'
    IAB01112 = 'IAB01112'
    IAB01114 = 'IAB01114'
    IAD03171 = 'IAD03171'
    IAD03173 = 'IAD03173'
    IAC02847 = 'IAC02847'
    IAC02848 = 'IAC02848'
    IAC02849 = 'IAC02849'
    IAB01118 = 'IAB01118'
    IAD03178 = 'IAD03178'
    IAD03179 = 'IAD03179'
    IAD03180 = 'IAD03180'
    IAC02851 = 'IAC02851'
    IAC02852 = 'IAC02852'
    IAD03167 = 'IAD03167'
    IAD03168 = 'IAD03168'
    IAB01154 = 'IAB01154'
    IAB01155 = 'IAB01155'
    IAB01156 = 'IAB01156'
    IAB01157 = 'IAB01157'
    IAC02853 = 'IAC02853'
    IAD03169 = 'IAD03169'
    IAB01158 = 'IAB01158'
    IAC02854 = 'IAC02854'
    IAB01163 = 'IAB01163'
    JAC02855 = 'JAC02855'
    JAB01167 = 'JAB01167'
    JAC02856 = 'JAC02856'
    JAB01168 = 'JAB01168'
    JAB01169 = 'JAB01169'
    JAB01170 = 'JAB01170'
    JAB01173 = 'JAB01173'
    JAB01174 = 'JAB01174'
    JAB01175 = 'JAB01175'
    JAB01176 = 'JAB01176'
    JAB01177 = 'JAB01177'
    JAB01178 = 'JAB01178'
    JAB01179 = 'JAB01179'
    JAB01180 = 'JAB01180'
    JAD03181 = 'JAD03181'
    KAD03182 = 'KAD03182'
    KAB01181 = 'KAB01181'
    KAC02857 = 'KAC02857'
    KAB01184 = 'KAB01184'
    KAD03183 = 'KAD03183'
    KAB01185 = 'KAB01185'
    KAB01186 = 'KAB01186'
    KAB01187 = 'KAB01187'
    KAB01192 = 'KAB01192'
    KAC02858 = 'KAC02858'
    KAB01194 = 'KAB01194'
    KAB01195 = 'KAB01195'
    LAB01196 = 'LAB01196'
    LAC02859 = 'LAC02859'
    LAC02860 = 'LAC02860'
    LAD03184 = 'LAD03184'
    LAB01246 = 'LAB01246'
    LAB01249 = 'LAB01249'
    LAB01251 = 'LAB01251'
    LAB01252 = 'LAB01252'
    LAB01253 = 'LAB01253'
    LAD03189 = 'LAD03189'
    LAC02864 = 'LAC02864'
    LAB01254 = 'LAB01254'
    LAB01255 = 'LAB01255'
    LAD03191 = 'LAD03191'
    LAB01259 = 'LAB01259'
    LAB01261 = 'LAB01261'
    LAB01262 = 'LAB01262'
    LAC02868 = 'LAC02868'
    LAB01265 = 'LAB01265'
    LAB01268 = 'LAB01268'
    LAD03195 = 'LAD03195'
    LAB01269 = 'LAB01269'
    LAB01271 = 'LAB01271'
    LAC02869 = 'LAC02869'
    LAC02870 = 'LAC02870'
    LAD03185 = 'LAD03185'
    LAD03187 = 'LAD03187'
    LAC02872 = 'LAC02872'
    LAB01275 = 'LAB01275'
    LAC02874 = 'LAC02874'
    LAD03190 = 'LAD03190'
    LAB01276 = 'LAB01276'
    LAC02875 = 'LAC02875'
    LAB01277 = 'LAB01277'
    LAB01278 = 'LAB01278'
    LAC02876 = 'LAC02876'
    LAC02877 = 'LAC02877'
    LAB01280 = 'LAB01280'
    LAD03188 = 'LAD03188'
    LAB01284 = 'LAB01284'
    LAB01285 = 'LAB01285'
    LAD03192 = 'LAD03192'
    LAB01289 = 'LAB01289'
    LAC02878 = 'LAC02878'
    LAB01293 = 'LAB01293'
    LAC02879 = 'LAC02879'
    LAB01294 = 'LAB01294'
    LAB01295 = 'LAB01295'
    LAB01296 = 'LAB01296'
    LAD03193 = 'LAD03193'
    LAD03194 = 'LAD03194'
    LAB01306 = 'LAB01306'
    LAB01307 = 'LAB01307'
    LAC02880 = 'LAC02880'
    LAB01309 = 'LAB01309'
    LAB01311 = 'LAB01311'
    LAB01312 = 'LAB01312'
    LAB01313 = 'LAB01313'
    SAB02293 = 'SAB02293'
    LAB01315 = 'LAB01315'
    LAB01317 = 'LAB01317'
    MAB01318 = 'MAB01318'
    MAB01319 = 'MAB01319'
    MAD03224 = 'MAD03224'
    MAB01358 = 'MAB01358'
    MAB01363 = 'MAB01363'
    MAD03201 = 'MAD03201'
    MAD03204 = 'MAD03204'
    MAD03207 = 'MAD03207'
    MAD03211 = 'MAD03211'
    MAB01367 = 'MAB01367'
    MAC02881 = 'MAC02881'
    MAC02882 = 'MAC02882'
    MAD03198 = 'MAD03198'
    MAD03202 = 'MAD03202'
    MAB01377 = 'MAB01377'
    MAD03216 = 'MAD03216'
    MAD03221 = 'MAD03221'
    MAB01390 = 'MAB01390'
    MAB01393 = 'MAB01393'
    MAB01394 = 'MAB01394'
    MAB01395 = 'MAB01395'
    MAD03222 = 'MAD03222'
    MAD03228 = 'MAD03228'
    MAD03230 = 'MAD03230'
    MAD03208 = 'MAD03208'
    MAD03212 = 'MAD03212'
    MAD03217 = 'MAD03217'
    MAD03225 = 'MAD03225'
    MAB01436 = 'MAB01436'
    MAD03235 = 'MAD03235'
    MAD03236 = 'MAD03236'
    MAD03237 = 'MAD03237'
    MAD03238 = 'MAD03238'
    MAD03232 = 'MAD03232'
    MAD03233 = 'MAD03233'
    MAD03234 = 'MAD03234'
    MAD03239 = 'MAD03239'
    MAB01451 = 'MAB01451'
    MAD03197 = 'MAD03197'
    MAB01453 = 'MAB01453'
    MAB01454 = 'MAB01454'
    MAB01456 = 'MAB01456'
    MAB01459 = 'MAB01459'
    MAB01460 = 'MAB01460'
    MAB01461 = 'MAB01461'
    MAB01462 = 'MAB01462'
    MAC02886 = 'MAC02886'
    MAC02887 = 'MAC02887'
    MAD03226 = 'MAD03226'
    MAC02885 = 'MAC02885'
    MAC02888 = 'MAC02888'
    MAC02889 = 'MAC02889'
    MAC02890 = 'MAC02890'
    MAD03196 = 'MAD03196'
    MAB01464 = 'MAB01464'
    MAB01465 = 'MAB01465'
    MAB01466 = 'MAB01466'
    MAB01467 = 'MAB01467'
    MAB01468 = 'MAB01468'
    MAB01469 = 'MAB01469'
    MAB01476 = 'MAB01476'
    MAC02891 = 'MAC02891'
    MAB01478 = 'MAB01478'
    MAB01482 = 'MAB01482'
    MAB01483 = 'MAB01483'
    MAB01484 = 'MAB01484'
    MAD03205 = 'MAD03205'
    MAD03209 = 'MAD03209'
    MAD03213 = 'MAD03213'
    MAB01496 = 'MAB01496'
    MAD03214 = 'MAD03214'
    MAD03218 = 'MAD03218'
    MAB01497 = 'MAB01497'
    MAB01499 = 'MAB01499'
    MAC02896 = 'MAC02896'
    MAC02897 = 'MAC02897'
    MAB01503 = 'MAB01503'
    MAB01504 = 'MAB01504'
    MAB01505 = 'MAB01505'
    MAD03210 = 'MAD03210'
    MAD03215 = 'MAD03215'
    MAD03219 = 'MAD03219'
    MAB01515 = 'MAB01515'
    MAC02901 = 'MAC02901'
    MAB01516 = 'MAB01516'
    MAB01517 = 'MAB01517'
    MAD03220 = 'MAD03220'
    MAD03223 = 'MAD03223'
    MAC02902 = 'MAC02902'
    MAD03199 = 'MAD03199'
    MAC02903 = 'MAC02903'
    MAB01529 = 'MAB01529'
    MAB01530 = 'MAB01530'
    MAB01531 = 'MAB01531'
    MAC02904 = 'MAC02904'
    MAB01532 = 'MAB01532'
    MAD03200 = 'MAD03200'
    MAD03203 = 'MAD03203'
    MAC02905 = 'MAC02905'
    MAB01546 = 'MAB01546'
    MAB01548 = 'MAB01548'
    MAC02906 = 'MAC02906'
    MAB01551 = 'MAB01551'
    MAC02907 = 'MAC02907'
    MAC02908 = 'MAC02908'
    MAC02909 = 'MAC02909'
    MAD03227 = 'MAD03227'
    MAD03229 = 'MAD03229'
    MAD03231 = 'MAD03231'
    MAB01564 = 'MAB01564'
    MAB01565 = 'MAB01565'
    MAB01566 = 'MAB01566'
    MAB01568 = 'MAB01568'
    MAB01569 = 'MAB01569'
    MAB01570 = 'MAB01570'
    MAB01571 = 'MAB01571'
    MAB01573 = 'MAB01573'
    MAB01574 = 'MAB01574'
    MAD03206 = 'MAD03206'
    NAD03241 = 'NAD03241'
    NAD03243 = 'NAD03243'
    NAC01811 = 'NAC01811'
    NAD03240 = 'NAD03240'
    NAB01575 = 'NAB01575'
    NAB01578 = 'NAB01578'
    NAB01579 = 'NAB01579'
    NAC01812 = 'NAC01812'
    NAC01814 = 'NAC01814'
    NAB01580 = 'NAB01580'
    NAB01581 = 'NAB01581'
    NAD03242 = 'NAD03242'
    NAB01587 = 'NAB01587'
    NAD03244 = 'NAD03244'
    NAB01591 = 'NAB01591'
    NAB01592 = 'NAB01592'
    NAB01597 = 'NAB01597'
    NAD03245 = 'NAD03245'
    NAB01598 = 'NAB01598'
    NAD03246 = 'NAD03246'
    NAB01599 = 'NAB01599'
    NAB01600 = 'NAB01600'
    NAC01817 = 'NAC01817'
    OAC01818 = 'OAC01818'
    OAB01601 = 'OAB01601'
    OAD03247 = 'OAD03247'
    OAD03251 = 'OAD03251'
    OAB01602 = 'OAB01602'
    OAB01604 = 'OAB01604'
    OAB01605 = 'OAB01605'
    OAB01606 = 'OAB01606'
    OAB01608 = 'OAB01608'
    OAD03248 = 'OAD03248'
    OAB01612 = 'OAB01612'
    OAB01613 = 'OAB01613'
    OAC08123 = 'OAC08123'
    OAB01616 = 'OAB01616'
    OAB01617 = 'OAB01617'
    OAB01618 = 'OAB01618'
    OAB01619 = 'OAB01619'
    OAB01620 = 'OAB01620'
    OAB01621 = 'OAB01621'
    OAB01622 = 'OAB01622'
    OAC01826 = 'OAC01826'
    OAB01625 = 'OAB01625'
    OAB01628 = 'OAB01628'
    OAB01629 = 'OAB01629'
    OAC01827 = 'OAC01827'
    OAB01630 = 'OAB01630'
    OAB01631 = 'OAB01631'
    OAD03382 = 'OAD03382'
    OAD03249 = 'OAD03249'
    OAD03250 = 'OAD03250'
    OAB01637 = 'OAB01637'
    OAB01638 = 'OAB01638'
    OAB01639 = 'OAB01639'
    OAB01643 = 'OAB01643'
    PAD03258 = 'PAD03258'
    PAC01857 = 'PAC01857'
    PAB01644 = 'PAB01644'
    PAD03261 = 'PAD03261'
    PAC01828 = 'PAC01828'
    PAB01666 = 'PAB01666'
    PAB01668 = 'PAB01668'
    PAB01669 = 'PAB01669'
    PAB01665 = 'PAB01665'
    PAD03272 = 'PAD03272'
    PAB01673 = 'PAB01673'
    PAB01674 = 'PAB01674'
    PAB01676 = 'PAB01676'
    PAB01677 = 'PAB01677'
    PAB01678 = 'PAB01678'
    PAB01679 = 'PAB01679'
    PAB01680 = 'PAB01680'
    PAB01681 = 'PAB01681'
    PAC01832 = 'PAC01832'
    PAB01682 = 'PAB01682'
    PAB01685 = 'PAB01685'
    PAB01687 = 'PAB01687'
    PAB01688 = 'PAB01688'
    PAB01691 = 'PAB01691'
    PAB01692 = 'PAB01692'
    PAC01834 = 'PAC01834'
    PAB01693 = 'PAB01693'
    PAD03259 = 'PAD03259'
    PAB01696 = 'PAB01696'
    PAB01697 = 'PAB01697'
    PAB01699 = 'PAB01699'
    PAB01701 = 'PAB01701'
    PAB01702 = 'PAB01702'
    PAB01703 = 'PAB01703'
    PAC01844 = 'PAC01844'
    PAD03383 = 'PAD03383'
    PAB01704 = 'PAB01704'
    PAC01845 = 'PAC01845'
    PAC01846 = 'PAC01846'
    PAB01705 = 'PAB01705'
    PAB01706 = 'PAB01706'
    PAB01707 = 'PAB01707'
    PAB01708 = 'PAB01708'
    PAB01709 = 'PAB01709'
    PAB01710 = 'PAB01710'
    PAB01711 = 'PAB01711'
    PAB01712 = 'PAB01712'
    PAC01848 = 'PAC01848'
    PAB01713 = 'PAB01713'
    PAB01714 = 'PAB01714'
    PAB01715 = 'PAB01715'
    PAD03263 = 'PAD03263'
    PAD03264 = 'PAD03264'
    PAD03268 = 'PAD03268'
    PAB01729 = 'PAB01729'
    PAB01731 = 'PAB01731'
    PAD03253 = 'PAD03253'
    PAB01735 = 'PAB01735'
    PAB01736 = 'PAB01736'
    PAC01849 = 'PAC01849'
    PAC01850 = 'PAC01850'
    PAC01851 = 'PAC01851'
    PAD03254 = 'PAD03254'
    PAB01747 = 'PAB01747'
    PAB01748 = 'PAB01748'
    PAB01752 = 'PAB01752'
    PAB01753 = 'PAB01753'
    PAB01754 = 'PAB01754'
    PAB01755 = 'PAB01755'
    PAB01756 = 'PAB01756'
    PAB01760 = 'PAB01760'
    PAB01757 = 'PAB01757'
    PAB01758 = 'PAB01758'
    PAB01759 = 'PAB01759'
    PAD03252 = 'PAD03252'
    PAB01761 = 'PAB01761'
    PAB01762 = 'PAB01762'
    PAC01852 = 'PAC01852'
    PAB01765 = 'PAB01765'
    PAB01766 = 'PAB01766'
    PAB01767 = 'PAB01767'
    PAB01768 = 'PAB01768'
    PAB01773 = 'PAB01773'
    PAD03260 = 'PAD03260'
    PAB01777 = 'PAB01777'
    PAB01780 = 'PAB01780'
    PAB01781 = 'PAB01781'
    PAB01782 = 'PAB01782'
    PAB01783 = 'PAB01783'
    PAB01785 = 'PAB01785'
    PAB01786 = 'PAB01786'
    PAB01787 = 'PAB01787'
    PAB01788 = 'PAB01788'
    PAC01853 = 'PAC01853'
    PAC01854 = 'PAC01854'
    PAB01790 = 'PAB01790'
    PAB01789 = 'PAB01789'
    PAB01791 = 'PAB01791'
    PAB01792 = 'PAB01792'
    PAB01793 = 'PAB01793'
    PAB01794 = 'PAB01794'
    PAB01795 = 'PAB01795'
    PAB01797 = 'PAB01797'
    PAB01798 = 'PAB01798'
    PAB01799 = 'PAB01799'
    PAB01800 = 'PAB01800'
    PAB01801 = 'PAB01801'
    PAB01802 = 'PAB01802'
    PAC01858 = 'PAC01858'
    PAB01806 = 'PAB01806'
    PAB01807 = 'PAB01807'
    PAB01808 = 'PAB01808'
    PAB01809 = 'PAB01809'
    PAB01810 = 'PAB01810'
    PAB01811 = 'PAB01811'
    PAD03255 = 'PAD03255'
    PAB01814 = 'PAB01814'
    PAB01817 = 'PAB01817'
    PAB01818 = 'PAB01818'
    PAB01819 = 'PAB01819'
    PAB01821 = 'PAB01821'
    PAC01860 = 'PAC01860'
    PAB01826 = 'PAB01826'
    PAB01827 = 'PAB01827'
    PAB01831 = 'PAB01831'
    PAD03256 = 'PAD03256'
    PAD03257 = 'PAD03257'
    PAB01868 = 'PAB01868'
    PAC01865 = 'PAC01865'
    PAC01866 = 'PAC01866'
    PAD03266 = 'PAD03266'
    PAB01899 = 'PAB01899'
    PAB01900 = 'PAB01900'
    PAB01901 = 'PAB01901'
    PAC01867 = 'PAC01867'
    PAD03271 = 'PAD03271'
    PAB01902 = 'PAB01902'
    PAB01905 = 'PAB01905'
    PAB01906 = 'PAB01906'
    PAB01907 = 'PAB01907'
    PAC01870 = 'PAC01870'
    PAC01871 = 'PAC01871'
    PAB01909 = 'PAB01909'
    PAB01910 = 'PAB01910'
    PAB01911 = 'PAB01911'
    PAB01913 = 'PAB01913'
    PAB01915 = 'PAB01915'
    PAB01916 = 'PAB01916'
    PAD03267 = 'PAD03267'
    PAB01923 = 'PAB01923'
    PAC01872 = 'PAC01872'
    PAB01924 = 'PAB01924'
    PAB01925 = 'PAB01925'
    PAB01927 = 'PAB01927'
    QAD03273 = 'QAD03273'
    QAD03274 = 'QAD03274'
    QAB01930 = 'QAB01930'
    QAB01931 = 'QAB01931'
    QAC01874 = 'QAC01874'
    QAB01933 = 'QAB01933'
    QAB01934 = 'QAB01934'
    RAB02043 = 'RAB02043'
    RAB01935 = 'RAB01935'
    RAD03278 = 'RAD03278'
    RAB01936 = 'RAB01936'
    RAB01937 = 'RAB01937'
    RAB01942 = 'RAB01942'
    RAC01877 = 'RAC01877'
    RAB01943 = 'RAB01943'
    RAC01875 = 'RAC01875'
    RAC01876 = 'RAC01876'
    RAB01947 = 'RAB01947'
    RAB01948 = 'RAB01948'
    RAD03281 = 'RAD03281'
    RAB01950 = 'RAB01950'
    RAB01959 = 'RAB01959'
    RAC01881 = 'RAC01881'
    RAB01960 = 'RAB01960'
    RAD03275 = 'RAD03275'
    RAB01961 = 'RAB01961'
    RAB01963 = 'RAB01963'
    RAC01882 = 'RAC01882'
    RAB01964 = 'RAB01964'
    RAC01883 = 'RAC01883'
    RAD03277 = 'RAD03277'
    RAB01967 = 'RAB01967'
    RAB01973 = 'RAB01973'
    RAB01974 = 'RAB01974'
    RAB01975 = 'RAB01975'
    RAC01885 = 'RAC01885'
    RAC01886 = 'RAC01886'
    RAC01887 = 'RAC01887'
    RAB01976 = 'RAB01976'
    RAB01978 = 'RAB01978'
    RAB01977 = 'RAB01977'
    RAB01979 = 'RAB01979'
    RAB01980 = 'RAB01980'
    RAC01888 = 'RAC01888'
    RAC01890 = 'RAC01890'
    RAC01891 = 'RAC01891'
    RAC01892 = 'RAC01892'
    RAB01983 = 'RAB01983'
    RAB01984 = 'RAB01984'
    RAC01894 = 'RAC01894'
    RAC01895 = 'RAC01895'
    RAC01896 = 'RAC01896'
    RAC01897 = 'RAC01897'
    RAB01985 = 'RAB01985'
    RAB01986 = 'RAB01986'
    RAB01987 = 'RAB01987'
    RAB01988 = 'RAB01988'
    RAB01989 = 'RAB01989'
    RAB01990 = 'RAB01990'
    RAB01991 = 'RAB01991'
    RAB01994 = 'RAB01994'
    RAB01992 = 'RAB01992'
    RAB01993 = 'RAB01993'
    RAB01995 = 'RAB01995'
    RAB01996 = 'RAB01996'
    RAD03279 = 'RAD03279'
    RAB02008 = 'RAB02008'
    RAC01900 = 'RAC01900'
    RAB02010 = 'RAB02010'
    RAD03384 = 'RAD03384'
    RAB02013 = 'RAB02013'
    RAB02015 = 'RAB02015'
    RAC01902 = 'RAC01902'
    RAB02016 = 'RAB02016'
    RAB02017 = 'RAB02017'
    RAD03280 = 'RAD03280'
    RAB02019 = 'RAB02019'
    RAB02020 = 'RAB02020'
    RAB02022 = 'RAB02022'
    RAD03276 = 'RAD03276'
    RAB02032 = 'RAB02032'
    RAB02033 = 'RAB02033'
    RAC01903 = 'RAC01903'
    RAB02035 = 'RAB02035'
    RAB02037 = 'RAB02037'
    RAB02039 = 'RAB02039'
    RAC01905 = 'RAC01905'
    RAC01906 = 'RAC01906'
    RAB02044 = 'RAB02044'
    SAB02047 = 'SAB02047'
    SAD03299 = 'SAD03299'
    SAB02048 = 'SAB02048'
    SAC01907 = 'SAC01907'
    SAD03300 = 'SAD03300'
    SAD03305 = 'SAD03305'
    SAC01908 = 'SAC01908'
    SAD03306 = 'SAD03306'
    SAD03312 = 'SAD03312'
    SAD03317 = 'SAD03317'
    SAD03319 = 'SAD03319'
    SAB02050 = 'SAB02050'
    SAB02051 = 'SAB02051'
    SAB02052 = 'SAB02052'
    SAD03283 = 'SAD03283'
    SAC01910 = 'SAC01910'
    SAB02056 = 'SAB02056'
    SAD03296 = 'SAD03296'
    SAB02064 = 'SAB02064'
    SAD03291 = 'SAD03291'
    SAB02068 = 'SAB02068'
    SAB02069 = 'SAB02069'
    SAD03313 = 'SAD03313'
    SAC01912 = 'SAC01912'
    SAC01913 = 'SAC01913'
    SAB02074 = 'SAB02074'
    SAB02076 = 'SAB02076'
    SAB02079 = 'SAB02079'
    SAB02081 = 'SAB02081'
    SAB02082 = 'SAB02082'
    SAB02084 = 'SAB02084'
    SAB02085 = 'SAB02085'
    SAB02087 = 'SAB02087'
    SAB02088 = 'SAB02088'
    SAD03307 = 'SAD03307'
    SAD03314 = 'SAD03314'
    SAB02093 = 'SAB02093'
    SAD03285 = 'SAD03285'
    SAB02096 = 'SAB02096'
    SAD03301 = 'SAD03301'
    SAB02106 = 'SAB02106'
    SAB02107 = 'SAB02107'
    SAB02108 = 'SAB02108'
    SAC01919 = 'SAC01919'
    SAD03315 = 'SAD03315'
    SAB02113 = 'SAB02113'
    SAB02114 = 'SAB02114'
    SAB02115 = 'SAB02115'
    SAD03294 = 'SAD03294'
    SAC01920 = 'SAC01920'
    SAB02119 = 'SAB02119'
    SAB02121 = 'SAB02121'
    SAB02123 = 'SAB02123'
    SAB02127 = 'SAB02127'
    SAB02128 = 'SAB02128'
    SAB02129 = 'SAB02129'
    SAB02133 = 'SAB02133'
    SAD03286 = 'SAD03286'
    SAD03292 = 'SAD03292'
    SAB02145 = 'SAB02145'
    SAB02146 = 'SAB02146'
    SAB02147 = 'SAB02147'
    SAD03302 = 'SAD03302'
    SAD03308 = 'SAD03308'
    SAD03316 = 'SAD03316'
    SAD03318 = 'SAD03318'
    SAB02159 = 'SAB02159'
    SAB02160 = 'SAB02160'
    SAB02163 = 'SAB02163'
    SAD03287 = 'SAD03287'
    SAB02167 = 'SAB02167'
    SAB02169 = 'SAB02169'
    SAC01922 = 'SAC01922'
    SAB02171 = 'SAB02171'
    SAB02172 = 'SAB02172'
    SAB02176 = 'SAB02176'
    SAB02177 = 'SAB02177'
    SAB02181 = 'SAB02181'
    SAB02182 = 'SAB02182'
    SAB02183 = 'SAB02183'
    SAB02184 = 'SAB02184'
    SAB02185 = 'SAB02185'
    SAB02186 = 'SAB02186'
    SAB02187 = 'SAB02187'
    SAB02188 = 'SAB02188'
    SAB02189 = 'SAB02189'
    SAB02190 = 'SAB02190'
    SAB02191 = 'SAB02191'
    SAB02192 = 'SAB02192'
    SAB02197 = 'SAB02197'
    SAB02198 = 'SAB02198'
    SAB02199 = 'SAB02199'
    SAB02200 = 'SAB02200'
    SAB02201 = 'SAB02201'
    SAB02205 = 'SAB02205'
    SAB02202 = 'SAB02202'
    SAB02203 = 'SAB02203'
    SAB02204 = 'SAB02204'
    SAD03295 = 'SAD03295'
    SAD03297 = 'SAD03297'
    SAD03303 = 'SAD03303'
    SAB02212 = 'SAB02212'
    SAB02214 = 'SAB02214'
    SAB02215 = 'SAB02215'
    SAB02217 = 'SAB02217'
    SAB02218 = 'SAB02218'
    SAB02219 = 'SAB02219'
    SAB02220 = 'SAB02220'
    SAB02224 = 'SAB02224'
    SAB02225 = 'SAB02225'
    SAB02226 = 'SAB02226'
    SAD03298 = 'SAD03298'
    SAB02235 = 'SAB02235'
    SAB02236 = 'SAB02236'
    SAB02237 = 'SAB02237'
    SAB02238 = 'SAB02238'
    SAD03309 = 'SAD03309'
    SAC01928 = 'SAC01928'
    SAB02242 = 'SAB02242'
    SAD03284 = 'SAD03284'
    SAD03288 = 'SAD03288'
    SAC01929 = 'SAC01929'
    SAB02253 = 'SAB02253'
    SAB02254 = 'SAB02254'
    SAB02255 = 'SAB02255'
    SAB02258 = 'SAB02258'
    SAB02263 = 'SAB02263'
    SAD03289 = 'SAD03289'
    SAB02267 = 'SAB02267'
    SAB02269 = 'SAB02269'
    SAB02270 = 'SAB02270'
    SAB02272 = 'SAB02272'
    SAB02273 = 'SAB02273'
    SAD03290 = 'SAD03290'
    SAD03293 = 'SAD03293'
    SAB02284 = 'SAB02284'
    SAB02285 = 'SAB02285'
    SAB02286 = 'SAB02286'
    SAD03304 = 'SAD03304'
    SAD03310 = 'SAD03310'
    SAB02298 = 'SAB02298'
    SAB02301 = 'SAB02301'
    SAB02305 = 'SAB02305'
    SAB02306 = 'SAB02306'
    SAB02307 = 'SAB02307'
    SAB02310 = 'SAB02310'
    SAD03282 = 'SAD03282'
    SAB02317 = 'SAB02317'
    SAB02318 = 'SAB02318'
    SAB02319 = 'SAB02319'
    SAB02320 = 'SAB02320'
    SAC01936 = 'SAC01936'
    SAB02322 = 'SAB02322'
    SAB02323 = 'SAB02323'
    SAC01937 = 'SAC01937'
    SAB02325 = 'SAB02325'
    SAB02326 = 'SAB02326'
    SAB02327 = 'SAB02327'
    SAD03311 = 'SAD03311'
    TAD03338 = 'TAD03338'
    TAD03340 = 'TAD03340'
    TAD03341 = 'TAD03341'
    TAB02333 = 'TAB02333'
    TAB02334 = 'TAB02334'
    TAD03327 = 'TAD03327'
    TAD03330 = 'TAD03330'
    TAD03332 = 'TAD03332'
    TAB02338 = 'TAB02338'
    TAB02339 = 'TAB02339'
    TAD03339 = 'TAD03339'
    TAB02340 = 'TAB02340'
    TAB02341 = 'TAB02341'
    TAC01941 = 'TAC01941'
    TAC01943 = 'TAC01943'
    TAB02342 = 'TAB02342'
    TAB02343 = 'TAB02343'
    TAD03325 = 'TAD03325'
    TAC01944 = 'TAC01944'
    TAD03328 = 'TAD03328'
    TAD03331 = 'TAD03331'
    TAD03333 = 'TAD03333'
    TAD03335 = 'TAD03335'
    TAB02360 = 'TAB02360'
    TAC01945 = 'TAC01945'
    TAB02365 = 'TAB02365'
    TAC01946 = 'TAC01946'
    TAB02366 = 'TAB02366'
    TAB02367 = 'TAB02367'
    TAB02368 = 'TAB02368'
    TAB02369 = 'TAB02369'
    TAB02370 = 'TAB02370'
    TAC01947 = 'TAC01947'
    TAB02371 = 'TAB02371'
    TAD03323 = 'TAD03323'
    TAD03324 = 'TAD03324'
    TAC01948 = 'TAC01948'
    TAD03336 = 'TAD03336'
    TAB02380 = 'TAB02380'
    TAD03321 = 'TAD03321'
    TAC01949 = 'TAC01949'
    TAB02393 = 'TAB02393'
    TAC01950 = 'TAC01950'
    TAB02398 = 'TAB02398'
    TAB02400 = 'TAB02400'
    TAB02401 = 'TAB02401'
    TAB02402 = 'TAB02402'
    TAB02405 = 'TAB02405'
    TAC01951 = 'TAC01951'
    TAB02412 = 'TAB02412'
    TAB02413 = 'TAB02413'
    TAB02414 = 'TAB02414'
    TAB02417 = 'TAB02417'
    TAB02418 = 'TAB02418'
    TAB02419 = 'TAB02419'
    TAB02420 = 'TAB02420'
    TAB02421 = 'TAB02421'
    TAB02426 = 'TAB02426'
    TAD03334 = 'TAD03334'
    TAB02427 = 'TAB02427'
    TAB02428 = 'TAB02428'
    TAB02429 = 'TAB02429'
    TAC01953 = 'TAC01953'
    TAD03326 = 'TAD03326'
    TAD03329 = 'TAD03329'
    TAB02432 = 'TAB02432'
    TAC01954 = 'TAC01954'
    TAC01955 = 'TAC01955'
    TAC01956 = 'TAC01956'
    TAB02434 = 'TAB02434'
    TAB02435 = 'TAB02435'
    TAB02436 = 'TAB02436'
    TAB02437 = 'TAB02437'
    TAB02438 = 'TAB02438'
    TAB02443 = 'TAB02443'
    TAB02449 = 'TAB02449'
    TAB02450 = 'TAB02450'
    TAC01957 = 'TAC01957'
    TAC01958 = 'TAC01958'
    TAD03337 = 'TAD03337'
    TAB02451 = 'TAB02451'
    TAB02452 = 'TAB02452'
    TAB02453 = 'TAB02453'
    TAB02454 = 'TAB02454'
    TAB02455 = 'TAB02455'
    TAB02457 = 'TAB02457'
    TAC01959 = 'TAC01959'
    TAB02459 = 'TAB02459'
    TAB02460 = 'TAB02460'
    TAD03322 = 'TAD03322'
    UAD03343 = 'UAD03343'
    UAD03344 = 'UAD03344'
    UAB02463 = 'UAB02463'
    UAB02464 = 'UAB02464'
    UAB02465 = 'UAB02465'
    UAC01960 = 'UAC01960'
    UAD03342 = 'UAD03342'
    UAC01961 = 'UAC01961'
    UAB02467 = 'UAB02467'
    UAB02469 = 'UAB02469'
    VAD03348 = 'VAD03348'
    VAB02470 = 'VAB02470'
    VAB02471 = 'VAB02471'
    VAD03345 = 'VAD03345'
    VAB02475 = 'VAB02475'
    VAB02476 = 'VAB02476'
    VAB02477 = 'VAB02477'
    VAB02478 = 'VAB02478'
    VAB02479 = 'VAB02479'
    VAC01962 = 'VAC01962'
    VAB02480 = 'VAB02480'
    VAB02481 = 'VAB02481'
    VAD03346 = 'VAD03346'
    VAB02482 = 'VAB02482'
    VAB02483 = 'VAB02483'
    VAB02485 = 'VAB02485'
    VAB02492 = 'VAB02492'
    VAC01963 = 'VAC01963'
    VAB02493 = 'VAB02493'
    VAD03347 = 'VAD03347'
    VAB02495 = 'VAB02495'
    VAB02496 = 'VAB02496'
    WAD03356 = 'WAD03356'
    WAB02499 = 'WAB02499'
    WAB02503 = 'WAB02503'
    WAB02506 = 'WAB02506'
    WAB02507 = 'WAB02507'
    WAB02508 = 'WAB02508'
    WAB02510 = 'WAB02510'
    WAB02513 = 'WAB02513'
    WAD03352 = 'WAD03352'
    WAD03353 = 'WAD03353'
    WAB02518 = 'WAB02518'
    WAC01964 = 'WAC01964'
    WAC01965 = 'WAC01965'
    WAB02519 = 'WAB02519'
    WAB02520 = 'WAB02520'
    WAB02521 = 'WAB02521'
    WAB02522 = 'WAB02522'
    WAD03351 = 'WAD03351'
    WAB02524 = 'WAB02524'
    WAD03354 = 'WAD03354'
    WAD03355 = 'WAD03355'
    WAD03357 = 'WAD03357'
    WAD03359 = 'WAD03359'
    WAB02529 = 'WAB02529'
    WAB02530 = 'WAB02530'
    WAD03349 = 'WAD03349'
    WAB02538 = 'WAB02538'
    WAB02541 = 'WAB02541'
    WAB02542 = 'WAB02542'
    WAB02546 = 'WAB02546'
    WAB02547 = 'WAB02547'
    WAB02556 = 'WAB02556'
    WAB02558 = 'WAB02558'
    WAB02561 = 'WAB02561'
    WAB02562 = 'WAB02562'
    WAB02564 = 'WAB02564'
    WAB02565 = 'WAB02565'
    WAB02566 = 'WAB02566'
    WAD03358 = 'WAD03358'
    WAD03360 = 'WAD03360'
    WAB02567 = 'WAB02567'
    WAB02570 = 'WAB02570'
    WAD03350 = 'WAD03350'
    WAB02574 = 'WAB02574'
    WAB02575 = 'WAB02575'
    WAC01966 = 'WAC01966'
    WAB02581 = 'WAB02581'
    WAB02583 = 'WAB02583'
    XAD03362 = 'XAD03362'
    YAD03363 = 'YAD03363'
    YAD03365 = 'YAD03365'
    YAB02585 = 'YAB02585'
    YAD03364 = 'YAD03364'
    YAD03366 = 'YAD03366'
    YAC01967 = 'YAC01967'
    YAC01968 = 'YAC01968'
    YAB02586 = 'YAB02586'
    YAD03367 = 'YAD03367'
    ZAD03370 = 'ZAD03370'
    ZAD03385 = 'ZAD03385'
    ZAD03368 = 'ZAD03368'
    ZAD03369 = 'ZAD03369'
    ZAD03371 = 'ZAD03371'
    ZAD03372 = 'ZAD03372'
    ZAD03373 = 'ZAD03373'
    ZAD03374 = 'ZAD03374'
    ZAB02587 = 'ZAB02587'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CdmOrigoCodes from a JSON string"""
        return cls(json.loads(json_str))


