# coding: utf-8

"""
    Acre Platform User API

    # CORS CORS is implemented by all Acre API endpoints and only certain hostnames are allowed for each deployment of the API. If your use case requires calling the Acre User API from a browser, please contact Acre to arrange the appropriate configuration. # API Authentication The primary method of authentication for users of the Acre API is with the use of JSON Web Tokens (JWTs), which are suplemented by an application specific API Key. The API key must be provided through the `X-API-KEY` HTTP header and will be provided by your Acre Customer Success Manager. The JWT must be provided through a cookie with key of `authorization`. The JWT must be generated and signed as per the following section. # Generating JWTs JWT must either be generated by a third-party such as Azure ADB2C that has been configured for the appropriate service and/or user account, or alternatively can be generated locally and signed by an private key for which the public key has been made available to Acre via a JWKS URL. In addition to being signed by your private key, the JWT will also need to contain at a minimum:  * An issuer `iss`, which must be a valid URI previously agreed with Acre.  * A subject `sub`, which must be a unique identifier for the user and/or service account previously agreed with Acre.  * An expiry time `exp` which must not be more than four hours in the future.  * A not before time `nbf` which must be in the past, but not greater than six hours in the past.  The JWT should be signed using RS256.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from acre_api.models.cdm_board_panel import CdmBoardPanel
from acre_api.models.cdm_compliance_process_config import CdmComplianceProcessConfig
from acre_api.models.cdm_org_template_config import CdmOrgTemplateConfig
from typing import Optional, Set
from typing_extensions import Self

class CdmProcessSettings(BaseModel):
    """
    CdmProcessSettings
    """ # noqa: E501
    use_exchange_case_status: Optional[StrictBool] = Field(default=None, description="A flag to indicate that Exchange case status should be used if needed in case status transition.")
    case_board: Optional[List[CdmBoardPanel]] = Field(default=None, description="Configuration for the Case Board.")
    template_config: Optional[List[CdmOrgTemplateConfig]] = Field(default=None, description="Allow config - particularly document names to be customized.")
    compliance: Optional[CdmComplianceProcessConfig] = None
    __properties: ClassVar[List[str]] = ["use_exchange_case_status", "case_board", "template_config", "compliance"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CdmProcessSettings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in case_board (list)
        _items = []
        if self.case_board:
            for _item_case_board in self.case_board:
                if _item_case_board:
                    _items.append(_item_case_board.to_dict())
            _dict['case_board'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in template_config (list)
        _items = []
        if self.template_config:
            for _item_template_config in self.template_config:
                if _item_template_config:
                    _items.append(_item_template_config.to_dict())
            _dict['template_config'] = _items
        # override the default output from pydantic by calling `to_dict()` of compliance
        if self.compliance:
            _dict['compliance'] = self.compliance.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CdmProcessSettings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "use_exchange_case_status": obj.get("use_exchange_case_status"),
            "case_board": [CdmBoardPanel.from_dict(_item) for _item in obj["case_board"]] if obj.get("case_board") is not None else None,
            "template_config": [CdmOrgTemplateConfig.from_dict(_item) for _item in obj["template_config"]] if obj.get("template_config") is not None else None,
            "compliance": CdmComplianceProcessConfig.from_dict(obj["compliance"]) if obj.get("compliance") is not None else None
        })
        return _obj


