# coding: utf-8

"""
    Acre Platform User API

    # CORS CORS is implemented by all Acre API endpoints and only certain hostnames are allowed for each deployment of the API. If your use case requires calling the Acre User API from a browser, please contact Acre to arrange the appropriate configuration. # API Authentication The primary method of authentication for users of the Acre API is with the use of JSON Web Tokens (JWTs), which are suplemented by an application specific API Key. The API key must be provided through the `X-API-KEY` HTTP header and will be provided by your Acre Customer Success Manager. The JWT must be provided through a cookie with key of `authorization`. The JWT must be generated and signed as per the following section. # Generating JWTs JWT must either be generated by a third-party such as Azure ADB2C that has been configured for the appropriate service and/or user account, or alternatively can be generated locally and signed by an private key for which the public key has been made available to Acre via a JWKS URL. In addition to being signed by your private key, the JWT will also need to contain at a minimum:  * An issuer `iss`, which must be a valid URI previously agreed with Acre.  * A subject `sub`, which must be a unique identifier for the user and/or service account previously agreed with Acre.  * An expiry time `exp` which must not be more than four hours in the future.  * A not before time `nbf` which must be in the past, but not greater than six hours in the past.  The JWT should be signed using RS256.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from acre_api.models.cdm_frequency import CdmFrequency
from acre_api.models.cdm_indexation_type import CdmIndexationType
from acre_api.models.cdm_payout_type import CdmPayoutType
from acre_api.models.cdm_premium_type import CdmPremiumType
from acre_api.models.cdm_product_benefit_add_ons import CdmProductBenefitAddOns
from acre_api.models.cdm_product_type import CdmProductType
from typing import Optional, Set
from typing_extensions import Self

class CdmProductBenefitTypeTerm(BaseModel):
    """
    CdmProductBenefitTypeTerm
    """ # noqa: E501
    client_ids: Optional[List[StrictStr]] = Field(default=None, description="The client(s) to whom the product benefit is tied.")
    product_type: Optional[CdmProductType] = CdmProductType.PRODUCT_TYPE_INVALID
    term_years: Optional[StrictInt] = Field(default=None, description="The duration of the policy in years.")
    cover_amount: Optional[StrictStr] = None
    cover_amount_frequency: Optional[CdmFrequency] = CdmFrequency.INVALID
    indexation_type: Optional[CdmIndexationType] = CdmIndexationType.INDEXATION_TYPE_INVALID
    indexation_percentage: Optional[StrictInt] = Field(default=None, description="Extent to which cover amount rises with time. Only if indexation_type is INDEXATION_TYPE_FIXED.")
    payout_type: Optional[CdmPayoutType] = CdmPayoutType.PAYOUT_TYPE_INVALID
    premium_type: Optional[CdmPremiumType] = CdmPremiumType.PREMIUM_TYPE_INVALID
    cover_amount_depreciation_rate: Optional[StrictInt] = Field(default=None, description="Rate at which benefit amount depreciates annually. Also known as policy interest rate.")
    product_add_ons: Optional[CdmProductBenefitAddOns] = None
    term_age: Optional[StrictInt] = Field(default=None, description="Clients age when the policy will end.")
    cover_amount_life: Optional[StrictStr] = Field(default=None, description="The amount of cover for life payout type.")
    cover_amount_cic: Optional[StrictStr] = Field(default=None, description="The amount of cover for critical illness payout type.")
    cover_amount_life_or_earlier_cic: Optional[StrictStr] = Field(default=None, description="The amount of cover for life or earlier critical illness payout type.")
    __properties: ClassVar[List[str]] = ["client_ids", "product_type", "term_years", "cover_amount", "cover_amount_frequency", "indexation_type", "indexation_percentage", "payout_type", "premium_type", "cover_amount_depreciation_rate", "product_add_ons", "term_age", "cover_amount_life", "cover_amount_cic", "cover_amount_life_or_earlier_cic"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CdmProductBenefitTypeTerm from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of product_add_ons
        if self.product_add_ons:
            _dict['product_add_ons'] = self.product_add_ons.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CdmProductBenefitTypeTerm from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "client_ids": obj.get("client_ids"),
            "product_type": obj.get("product_type") if obj.get("product_type") is not None else CdmProductType.PRODUCT_TYPE_INVALID,
            "term_years": obj.get("term_years"),
            "cover_amount": obj.get("cover_amount"),
            "cover_amount_frequency": obj.get("cover_amount_frequency") if obj.get("cover_amount_frequency") is not None else CdmFrequency.INVALID,
            "indexation_type": obj.get("indexation_type") if obj.get("indexation_type") is not None else CdmIndexationType.INDEXATION_TYPE_INVALID,
            "indexation_percentage": obj.get("indexation_percentage"),
            "payout_type": obj.get("payout_type") if obj.get("payout_type") is not None else CdmPayoutType.PAYOUT_TYPE_INVALID,
            "premium_type": obj.get("premium_type") if obj.get("premium_type") is not None else CdmPremiumType.PREMIUM_TYPE_INVALID,
            "cover_amount_depreciation_rate": obj.get("cover_amount_depreciation_rate"),
            "product_add_ons": CdmProductBenefitAddOns.from_dict(obj["product_add_ons"]) if obj.get("product_add_ons") is not None else None,
            "term_age": obj.get("term_age"),
            "cover_amount_life": obj.get("cover_amount_life"),
            "cover_amount_cic": obj.get("cover_amount_cic"),
            "cover_amount_life_or_earlier_cic": obj.get("cover_amount_life_or_earlier_cic")
        })
        return _obj


