# coding: utf-8

"""
    Acre Platform User API

    # CORS CORS is implemented by all Acre API endpoints and only certain hostnames are allowed for each deployment of the API. If your use case requires calling the Acre User API from a browser, please contact Acre to arrange the appropriate configuration. # API Authentication The primary method of authentication for users of the Acre API is with the use of JSON Web Tokens (JWTs), which are suplemented by an application specific API Key. The API key must be provided through the `X-API-KEY` HTTP header and will be provided by your Acre Customer Success Manager. The JWT must be provided through a cookie with key of `authorization`. The JWT must be generated and signed as per the following section. # Generating JWTs JWT must either be generated by a third-party such as Azure ADB2C that has been configured for the appropriate service and/or user account, or alternatively can be generated locally and signed by an private key for which the public key has been made available to Acre via a JWKS URL. In addition to being signed by your private key, the JWT will also need to contain at a minimum:  * An issuer `iss`, which must be a valid URI previously agreed with Acre.  * A subject `sub`, which must be a unique identifier for the user and/or service account previously agreed with Acre.  * An expiry time `exp` which must not be more than four hours in the future.  * A not before time `nbf` which must be in the past, but not greater than six hours in the past.  The JWT should be signed using RS256.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from acre_api.models.cdm_requirements_ip import CdmRequirementsIP
from acre_api.models.cdm_requirements_lci_and_fib import CdmRequirementsLCIAndFIB
from acre_api.models.cdm_requirements_objectives import CdmRequirementsObjectives
from acre_api.models.cdm_requirements_pmi import CdmRequirementsPMI
from acre_api.models.cdm_requirements_wo_l import CdmRequirementsWoL
from typing import Optional, Set
from typing_extensions import Self

class CdmProtectionRequirements(BaseModel):
    """
    The protection requirements for a given case.
    """ # noqa: E501
    objectives: Optional[CdmRequirementsObjectives] = None
    life_and_critical_illness: Optional[List[CdmRequirementsLCIAndFIB]] = Field(default=None, description="The life and critical illness requirements.")
    family_income_benefits: Optional[List[CdmRequirementsLCIAndFIB]] = Field(default=None, description="The family income benefits requirements.")
    income_protection: Optional[List[CdmRequirementsIP]] = Field(default=None, description="The income protection requirements.")
    whole_of_life: Optional[List[CdmRequirementsWoL]] = Field(default=None, description="The whole of life requirements.")
    private_medical_insurance: Optional[List[CdmRequirementsPMI]] = Field(default=None, description="The private medical insurance requirements.")
    __properties: ClassVar[List[str]] = ["objectives", "life_and_critical_illness", "family_income_benefits", "income_protection", "whole_of_life", "private_medical_insurance"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CdmProtectionRequirements from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of objectives
        if self.objectives:
            _dict['objectives'] = self.objectives.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in life_and_critical_illness (list)
        _items = []
        if self.life_and_critical_illness:
            for _item_life_and_critical_illness in self.life_and_critical_illness:
                if _item_life_and_critical_illness:
                    _items.append(_item_life_and_critical_illness.to_dict())
            _dict['life_and_critical_illness'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in family_income_benefits (list)
        _items = []
        if self.family_income_benefits:
            for _item_family_income_benefits in self.family_income_benefits:
                if _item_family_income_benefits:
                    _items.append(_item_family_income_benefits.to_dict())
            _dict['family_income_benefits'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in income_protection (list)
        _items = []
        if self.income_protection:
            for _item_income_protection in self.income_protection:
                if _item_income_protection:
                    _items.append(_item_income_protection.to_dict())
            _dict['income_protection'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in whole_of_life (list)
        _items = []
        if self.whole_of_life:
            for _item_whole_of_life in self.whole_of_life:
                if _item_whole_of_life:
                    _items.append(_item_whole_of_life.to_dict())
            _dict['whole_of_life'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in private_medical_insurance (list)
        _items = []
        if self.private_medical_insurance:
            for _item_private_medical_insurance in self.private_medical_insurance:
                if _item_private_medical_insurance:
                    _items.append(_item_private_medical_insurance.to_dict())
            _dict['private_medical_insurance'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CdmProtectionRequirements from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "objectives": CdmRequirementsObjectives.from_dict(obj["objectives"]) if obj.get("objectives") is not None else None,
            "life_and_critical_illness": [CdmRequirementsLCIAndFIB.from_dict(_item) for _item in obj["life_and_critical_illness"]] if obj.get("life_and_critical_illness") is not None else None,
            "family_income_benefits": [CdmRequirementsLCIAndFIB.from_dict(_item) for _item in obj["family_income_benefits"]] if obj.get("family_income_benefits") is not None else None,
            "income_protection": [CdmRequirementsIP.from_dict(_item) for _item in obj["income_protection"]] if obj.get("income_protection") is not None else None,
            "whole_of_life": [CdmRequirementsWoL.from_dict(_item) for _item in obj["whole_of_life"]] if obj.get("whole_of_life") is not None else None,
            "private_medical_insurance": [CdmRequirementsPMI.from_dict(_item) for _item in obj["private_medical_insurance"]] if obj.get("private_medical_insurance") is not None else None
        })
        return _obj


