# coding: utf-8

"""
    Acre Platform User API

    # CORS CORS is implemented by all Acre API endpoints and only certain hostnames are allowed for each deployment of the API. If your use case requires calling the Acre User API from a browser, please contact Acre to arrange the appropriate configuration. # API Authentication The primary method of authentication for users of the Acre API is with the use of JSON Web Tokens (JWTs), which are suplemented by an application specific API Key. The API key must be provided through the `X-API-KEY` HTTP header and will be provided by your Acre Customer Success Manager. The JWT must be provided through a cookie with key of `authorization`. The JWT must be generated and signed as per the following section. # Generating JWTs JWT must either be generated by a third-party such as Azure ADB2C that has been configured for the appropriate service and/or user account, or alternatively can be generated locally and signed by an private key for which the public key has been made available to Acre via a JWKS URL. In addition to being signed by your private key, the JWT will also need to contain at a minimum:  * An issuer `iss`, which must be a valid URI previously agreed with Acre.  * A subject `sub`, which must be a unique identifier for the user and/or service account previously agreed with Acre.  * An expiry time `exp` which must not be more than four hours in the future.  * A not before time `nbf` which must be in the past, but not greater than six hours in the past.  The JWT should be signed using RS256.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from acre_api.models.question_event_trigger import QuestionEventTrigger
from acre_api.models.question_question_type import QuestionQuestionType
from typing import Optional, Set
from typing_extensions import Self

class CdmQuestion(BaseModel):
    """
    Question type defines how we represent a question of a survey.
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="id holds the uuidv4 of the question entity.")
    question: Optional[StrictStr] = None
    version: Optional[StrictInt] = Field(default=None, description="version is the version number of the entity in the blockchain. Notice that this is not the same versioning pattern as the other entities (case, client...), this version will be increased manually and the questions with the version are defined in code statically.")
    type: Optional[QuestionQuestionType] = QuestionQuestionType.INVALID_QUESTION_TYPE
    event_trigger: Optional[QuestionEventTrigger] = None
    choices: Optional[List[StrictStr]] = Field(default=None, description="choices contains a list of choices of the question that the client can chose.")
    order: Optional[StrictInt] = Field(default=None, description="order holds a random integer value used for ordering the questions returned by the survey api.")
    required: Optional[StrictBool] = Field(default=None, description="required represents if the user is required or not to answer the question.")
    topic: Optional[StrictStr] = Field(default=None, description="topic is the topic description of the question.")
    __properties: ClassVar[List[str]] = ["id", "question", "version", "type", "event_trigger", "choices", "order", "required", "topic"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CdmQuestion from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of event_trigger
        if self.event_trigger:
            _dict['event_trigger'] = self.event_trigger.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CdmQuestion from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "question": obj.get("question"),
            "version": obj.get("version"),
            "type": obj.get("type") if obj.get("type") is not None else QuestionQuestionType.INVALID_QUESTION_TYPE,
            "event_trigger": QuestionEventTrigger.from_dict(obj["event_trigger"]) if obj.get("event_trigger") is not None else None,
            "choices": obj.get("choices"),
            "order": obj.get("order"),
            "required": obj.get("required"),
            "topic": obj.get("topic")
        })
        return _obj


