# coding: utf-8

"""
    Acre Platform User API

    # CORS CORS is implemented by all Acre API endpoints and only certain hostnames are allowed for each deployment of the API. If your use case requires calling the Acre User API from a browser, please contact Acre to arrange the appropriate configuration. # API Authentication The primary method of authentication for users of the Acre API is with the use of JSON Web Tokens (JWTs), which are suplemented by an application specific API Key. The API key must be provided through the `X-API-KEY` HTTP header and will be provided by your Acre Customer Success Manager. The JWT must be provided through a cookie with key of `authorization`. The JWT must be generated and signed as per the following section. # Generating JWTs JWT must either be generated by a third-party such as Azure ADB2C that has been configured for the appropriate service and/or user account, or alternatively can be generated locally and signed by an private key for which the public key has been made available to Acre via a JWKS URL. In addition to being signed by your private key, the JWT will also need to contain at a minimum:  * An issuer `iss`, which must be a valid URI previously agreed with Acre.  * A subject `sub`, which must be a unique identifier for the user and/or service account previously agreed with Acre.  * An expiry time `exp` which must not be more than four hours in the future.  * A not before time `nbf` which must be in the past, but not greater than six hours in the past.  The JWT should be signed using RS256.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from acre_api.models.cdm_contact_history import CdmContactHistory
from acre_api.models.referral_email_tracking_status import ReferralEmailTrackingStatus
from acre_api.models.referral_referral_partner import ReferralReferralPartner
from acre_api.models.referral_referral_source import ReferralReferralSource
from acre_api.models.referral_referral_status import ReferralReferralStatus
from acre_api.models.referral_referral_type import ReferralReferralType
from typing import Optional, Set
from typing_extensions import Self

class CdmReferral(BaseModel):
    """
    A referral made to partners eg conveyancing, insurance.
    """ # noqa: E501
    referral_type: Optional[ReferralReferralType] = ReferralReferralType.INVALID_TYPE
    partner: Optional[ReferralReferralPartner] = ReferralReferralPartner.INVALID_REFERRAL_PARTNER
    third_party_id: Optional[StrictStr] = None
    status: Optional[ReferralReferralStatus] = ReferralReferralStatus.INVALID_STATUS
    email_status: Optional[ReferralEmailTrackingStatus] = ReferralEmailTrackingStatus.NOT_SET
    created_at: Optional[StrictStr] = None
    modified_at: Optional[StrictStr] = None
    contact_history: Optional[List[CdmContactHistory]] = None
    referral_source: Optional[ReferralReferralSource] = ReferralReferralSource.UNSPECIFIED
    referral_source_id: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["referral_type", "partner", "third_party_id", "status", "email_status", "created_at", "modified_at", "contact_history", "referral_source", "referral_source_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CdmReferral from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in contact_history (list)
        _items = []
        if self.contact_history:
            for _item_contact_history in self.contact_history:
                if _item_contact_history:
                    _items.append(_item_contact_history.to_dict())
            _dict['contact_history'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CdmReferral from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "referral_type": obj.get("referral_type") if obj.get("referral_type") is not None else ReferralReferralType.INVALID_TYPE,
            "partner": obj.get("partner") if obj.get("partner") is not None else ReferralReferralPartner.INVALID_REFERRAL_PARTNER,
            "third_party_id": obj.get("third_party_id"),
            "status": obj.get("status") if obj.get("status") is not None else ReferralReferralStatus.INVALID_STATUS,
            "email_status": obj.get("email_status") if obj.get("email_status") is not None else ReferralEmailTrackingStatus.NOT_SET,
            "created_at": obj.get("created_at"),
            "modified_at": obj.get("modified_at"),
            "contact_history": [CdmContactHistory.from_dict(_item) for _item in obj["contact_history"]] if obj.get("contact_history") is not None else None,
            "referral_source": obj.get("referral_source") if obj.get("referral_source") is not None else ReferralReferralSource.UNSPECIFIED,
            "referral_source_id": obj.get("referral_source_id")
        })
        return _obj


