# coding: utf-8

"""
    Acre Platform User API

    # CORS CORS is implemented by all Acre API endpoints and only certain hostnames are allowed for each deployment of the API. If your use case requires calling the Acre User API from a browser, please contact Acre to arrange the appropriate configuration. # API Authentication The primary method of authentication for users of the Acre API is with the use of JSON Web Tokens (JWTs), which are suplemented by an application specific API Key. The API key must be provided through the `X-API-KEY` HTTP header and will be provided by your Acre Customer Success Manager. The JWT must be provided through a cookie with key of `authorization`. The JWT must be generated and signed as per the following section. # Generating JWTs JWT must either be generated by a third-party such as Azure ADB2C that has been configured for the appropriate service and/or user account, or alternatively can be generated locally and signed by an private key for which the public key has been made available to Acre via a JWKS URL. In addition to being signed by your private key, the JWT will also need to contain at a minimum:  * An issuer `iss`, which must be a valid URI previously agreed with Acre.  * A subject `sub`, which must be a unique identifier for the user and/or service account previously agreed with Acre.  * An expiry time `exp` which must not be more than four hours in the future.  * A not before time `nbf` which must be in the past, but not greater than six hours in the past.  The JWT should be signed using RS256.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from acre_api.models.cdm_case_details_flag_type import CdmCaseDetailsFlagType
from acre_api.models.cdm_document_metadata import CdmDocumentMetadata
from acre_api.models.cdm_template_name import CdmTemplateName
from typing import Optional, Set
from typing_extensions import Self

class CdmTemplateContextRequest(BaseModel):
    """
    Request to get the context a template would be rendered with.
    """ # noqa: E501
    template_name: Optional[CdmTemplateName] = CdmTemplateName.INVALID_TEMPLATE_NAME
    organisation_ids: Optional[List[StrictStr]] = Field(default=None, description="Organisation object references whose values will be available in the template.")
    user_ids: Optional[List[StrictStr]] = Field(default=None, description="User object references whose values will be available in the template.")
    client_ids: Optional[List[StrictStr]] = Field(default=None, description="Client object references whose values will be available in the template.")
    case_ids: Optional[List[StrictStr]] = Field(default=None, description="Case object references whose values will be available in the template.")
    mortgage_ids: Optional[List[StrictStr]] = Field(default=None, description="Mortgage object references whose values will be available in the template.")
    product_ids: Optional[List[StrictStr]] = Field(default=None, description="Product object references whose values will be available in the template.")
    note_ids: Optional[List[StrictStr]] = Field(default=None, description="Note object references whose values will be available in the template.")
    metadata: Optional[CdmDocumentMetadata] = None
    rendered_compliance_email_flag_type: Optional[CdmCaseDetailsFlagType] = CdmCaseDetailsFlagType.INVALID_FLAG_TYPE
    __properties: ClassVar[List[str]] = ["template_name", "organisation_ids", "user_ids", "client_ids", "case_ids", "mortgage_ids", "product_ids", "note_ids", "metadata", "rendered_compliance_email_flag_type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CdmTemplateContextRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of metadata
        if self.metadata:
            _dict['metadata'] = self.metadata.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CdmTemplateContextRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "template_name": obj.get("template_name") if obj.get("template_name") is not None else CdmTemplateName.INVALID_TEMPLATE_NAME,
            "organisation_ids": obj.get("organisation_ids"),
            "user_ids": obj.get("user_ids"),
            "client_ids": obj.get("client_ids"),
            "case_ids": obj.get("case_ids"),
            "mortgage_ids": obj.get("mortgage_ids"),
            "product_ids": obj.get("product_ids"),
            "note_ids": obj.get("note_ids"),
            "metadata": CdmDocumentMetadata.from_dict(obj["metadata"]) if obj.get("metadata") is not None else None,
            "rendered_compliance_email_flag_type": obj.get("rendered_compliance_email_flag_type") if obj.get("rendered_compliance_email_flag_type") is not None else CdmCaseDetailsFlagType.INVALID_FLAG_TYPE
        })
        return _obj


