# coding: utf-8

"""
    Acre Platform User API

    # CORS CORS is implemented by all Acre API endpoints and only certain hostnames are allowed for each deployment of the API. If your use case requires calling the Acre User API from a browser, please contact Acre to arrange the appropriate configuration. # API Authentication The primary method of authentication for users of the Acre API is with the use of JSON Web Tokens (JWTs), which are suplemented by an application specific API Key. The API key must be provided through the `X-API-KEY` HTTP header and will be provided by your Acre Customer Success Manager. The JWT must be provided through a cookie with key of `authorization`. The JWT must be generated and signed as per the following section. # Generating JWTs JWT must either be generated by a third-party such as Azure ADB2C that has been configured for the appropriate service and/or user account, or alternatively can be generated locally and signed by an private key for which the public key has been made available to Acre via a JWKS URL. In addition to being signed by your private key, the JWT will also need to contain at a minimum:  * An issuer `iss`, which must be a valid URI previously agreed with Acre.  * A subject `sub`, which must be a unique identifier for the user and/or service account previously agreed with Acre.  * An expiry time `exp` which must not be more than four hours in the future.  * A not before time `nbf` which must be in the past, but not greater than six hours in the past.  The JWT should be signed using RS256.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class CdmTemplateName(str, Enum):
    """
    Valid names for a template.   - INVALID_TEMPLATE_NAME: Unknown template name.  - NETWORK_PRIVACY_NOTICE: Network Privacy Notice that is set on the Principle and enforced on all ARs  - ORGANISATION_PRIVACY_NOTICE: Organisation (i.e. Brokerage) Privacy Notice  - IDD: IDD describing a firms services and fees.  - VERBAL_IDD: Verbal version of IDD  - WELCOME_EMAIL: Default welcome e-mail.  - WELCOME_EMAIL_AUTOMATED: Welcome e-mail when case is created.  - WELCOME_EMAIL_KBA: Welcome e-mail when broker invites client.  - ESIS: ESIS  - SUITABILITY_REPORT: Suitability Report  - COMPLIANCE_NOTIFICATION_EMAIL: Compliance notification email.  - CLIENT_PORTAL_IDD: Client portal version of IDD.  - PROTECTION_SUITABILITY_REPORT: Suitability Report for protection-only cases.  - CLIENT_EMAIL: Parent type for client emails  - SCHEDULING_EMAIL: Scheduling meeting invite email.  - FACT_FIND: Fact find template.
    """

    """
    allowed enum values
    """
    INVALID_TEMPLATE_NAME = 'INVALID_TEMPLATE_NAME'
    NETWORK_PRIVACY_NOTICE = 'NETWORK_PRIVACY_NOTICE'
    ORGANISATION_PRIVACY_NOTICE = 'ORGANISATION_PRIVACY_NOTICE'
    IDD = 'IDD'
    VERBAL_IDD = 'VERBAL_IDD'
    WELCOME_EMAIL = 'WELCOME_EMAIL'
    WELCOME_EMAIL_AUTOMATED = 'WELCOME_EMAIL_AUTOMATED'
    WELCOME_EMAIL_KBA = 'WELCOME_EMAIL_KBA'
    ESIS = 'ESIS'
    SUITABILITY_REPORT = 'SUITABILITY_REPORT'
    COMPLIANCE_NOTIFICATION_EMAIL = 'COMPLIANCE_NOTIFICATION_EMAIL'
    CLIENT_PORTAL_IDD = 'CLIENT_PORTAL_IDD'
    PROTECTION_SUITABILITY_REPORT = 'PROTECTION_SUITABILITY_REPORT'
    CLIENT_EMAIL = 'CLIENT_EMAIL'
    SCHEDULING_EMAIL = 'SCHEDULING_EMAIL'
    FACT_FIND = 'FACT_FIND'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CdmTemplateName from a JSON string"""
        return cls(json.loads(json_str))


