# coding: utf-8

"""
    Acre Platform User API

    # CORS CORS is implemented by all Acre API endpoints and only certain hostnames are allowed for each deployment of the API. If your use case requires calling the Acre User API from a browser, please contact Acre to arrange the appropriate configuration. # API Authentication The primary method of authentication for users of the Acre API is with the use of JSON Web Tokens (JWTs), which are suplemented by an application specific API Key. The API key must be provided through the `X-API-KEY` HTTP header and will be provided by your Acre Customer Success Manager. The JWT must be provided through a cookie with key of `authorization`. The JWT must be generated and signed as per the following section. # Generating JWTs JWT must either be generated by a third-party such as Azure ADB2C that has been configured for the appropriate service and/or user account, or alternatively can be generated locally and signed by an private key for which the public key has been made available to Acre via a JWKS URL. In addition to being signed by your private key, the JWT will also need to contain at a minimum:  * An issuer `iss`, which must be a valid URI previously agreed with Acre.  * A subject `sub`, which must be a unique identifier for the user and/or service account previously agreed with Acre.  * An expiry time `exp` which must not be more than four hours in the future.  * A not before time `nbf` which must be in the past, but not greater than six hours in the past.  The JWT should be signed using RS256.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from acre_api.models.cdm_case import CdmCase
from acre_api.models.cdm_document import CdmDocument
from acre_api.models.cdm_enbs_message import CdmENBSMessage
from acre_api.models.cdm_verification_collection import CdmVerificationCollection
from acre_api.models.v1_exception import V1Exception
from typing import Optional, Set
from typing_extensions import Self

class CdmUpdateCaseStatusResponse(BaseModel):
    """
    Response to update of a case's status.
    """ # noqa: E501
    exception: Optional[V1Exception] = None
    verification_collections: Optional[List[CdmVerificationCollection]] = Field(default=None, description="Conducted verifications and their statuses if there are failures.")
    update_failed: Optional[StrictBool] = Field(default=None, description="There are cases where the new case status is not the expected status, e.g. the case might have been moved to review as part of recommendation. These are not considered failures.")
    documents: Optional[List[CdmDocument]] = Field(default=None, description="A list of rendered documents as part of this transition, includes compliance notification emails.")
    enbs_message: Optional[CdmENBSMessage] = None
    case: Optional[CdmCase] = None
    __properties: ClassVar[List[str]] = ["exception", "verification_collections", "update_failed", "documents", "enbs_message", "case"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CdmUpdateCaseStatusResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of exception
        if self.exception:
            _dict['exception'] = self.exception.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in verification_collections (list)
        _items = []
        if self.verification_collections:
            for _item_verification_collections in self.verification_collections:
                if _item_verification_collections:
                    _items.append(_item_verification_collections.to_dict())
            _dict['verification_collections'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in documents (list)
        _items = []
        if self.documents:
            for _item_documents in self.documents:
                if _item_documents:
                    _items.append(_item_documents.to_dict())
            _dict['documents'] = _items
        # override the default output from pydantic by calling `to_dict()` of enbs_message
        if self.enbs_message:
            _dict['enbs_message'] = self.enbs_message.to_dict()
        # override the default output from pydantic by calling `to_dict()` of case
        if self.case:
            _dict['case'] = self.case.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CdmUpdateCaseStatusResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "exception": V1Exception.from_dict(obj["exception"]) if obj.get("exception") is not None else None,
            "verification_collections": [CdmVerificationCollection.from_dict(_item) for _item in obj["verification_collections"]] if obj.get("verification_collections") is not None else None,
            "update_failed": obj.get("update_failed"),
            "documents": [CdmDocument.from_dict(_item) for _item in obj["documents"]] if obj.get("documents") is not None else None,
            "enbs_message": CdmENBSMessage.from_dict(obj["enbs_message"]) if obj.get("enbs_message") is not None else None,
            "case": CdmCase.from_dict(obj["case"]) if obj.get("case") is not None else None
        })
        return _obj


