# coding: utf-8

"""
    Acre Platform User API

    # CORS CORS is implemented by all Acre API endpoints and only certain hostnames are allowed for each deployment of the API. If your use case requires calling the Acre User API from a browser, please contact Acre to arrange the appropriate configuration. # API Authentication The primary method of authentication for users of the Acre API is with the use of JSON Web Tokens (JWTs), which are suplemented by an application specific API Key. The API key must be provided through the `X-API-KEY` HTTP header and will be provided by your Acre Customer Success Manager. The JWT must be provided through a cookie with key of `authorization`. The JWT must be generated and signed as per the following section. # Generating JWTs JWT must either be generated by a third-party such as Azure ADB2C that has been configured for the appropriate service and/or user account, or alternatively can be generated locally and signed by an private key for which the public key has been made available to Acre via a JWKS URL. In addition to being signed by your private key, the JWT will also need to contain at a minimum:  * An issuer `iss`, which must be a valid URI previously agreed with Acre.  * A subject `sub`, which must be a unique identifier for the user and/or service account previously agreed with Acre.  * An expiry time `exp` which must not be more than four hours in the future.  * A not before time `nbf` which must be in the past, but not greater than six hours in the past.  The JWT should be signed using RS256.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class MortgageProductDetailsMortgageClubProcFee(BaseModel):
    """
    A proc fee available for this product through a mortgage club.
    """ # noqa: E501
    mortgage_club_code: Optional[StrictStr] = Field(default=None, description="The code used to identify the mortgage club.")
    mortgage_club_name: Optional[StrictStr] = Field(default=None, description="The name of the mortgage club.")
    proc_fee_code: Optional[StrictStr] = Field(default=None, description="The proc fee code.")
    proc_fee: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="**DEPRECATED** Use proc_fee_fixed. The gross proc fee amount.")
    net_proc_fee: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="**DEPRECATED** Use net_proc_fee_fixed. The net proc fee amount (when available, otherwise 0).")
    proc_fee_fixed: Optional[StrictStr] = Field(default=None, description="If the proc fee is fixed, then it is fixed to this amount (in pence, not GBP). (This value is for the lender/packager proc fee).")
    proc_fee_percentage: Optional[StrictInt] = Field(default=None, description="Proc fee based on this percentage of loan amount, represented as 1/100000 of a percent (precision for up to 5 decimal places). (This value is for the lender/packager proc fee).")
    proc_fee_min: Optional[StrictStr] = Field(default=None, description="Minimum proc fee if using percentage (in pence, not GBP). (This value is for the lender/packager proc fee).")
    proc_fee_max: Optional[StrictStr] = Field(default=None, description="Maximum proc fee if using percentage (in pence, not GBP). (This value is for the lender/packager proc fee).")
    net_proc_fee_fixed: Optional[StrictStr] = Field(default=None, description="The net proc fee is fixed to this amount (in pence, not GBP). (This value is for the lender/packager proc fee).")
    net_proc_fee_percentage: Optional[StrictInt] = Field(default=None, description="The net proc fee is this percentage of the loan amount, represented as 1/100000 of a percent (precision for up to 5 decimal places).. (This value is for the lender/packager proc fee).")
    net_proc_fee_min: Optional[StrictStr] = Field(default=None, description="The minimum amount for the net proc fee (in pence, not GBP). (This value is for the lender/packager proc fee).")
    net_proc_fee_max: Optional[StrictStr] = Field(default=None, description="The maximum amount for the net proc fee (in pence, not GBP). (This value is for the lender/packager proc fee).")
    __properties: ClassVar[List[str]] = ["mortgage_club_code", "mortgage_club_name", "proc_fee_code", "proc_fee", "net_proc_fee", "proc_fee_fixed", "proc_fee_percentage", "proc_fee_min", "proc_fee_max", "net_proc_fee_fixed", "net_proc_fee_percentage", "net_proc_fee_min", "net_proc_fee_max"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MortgageProductDetailsMortgageClubProcFee from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MortgageProductDetailsMortgageClubProcFee from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "mortgage_club_code": obj.get("mortgage_club_code"),
            "mortgage_club_name": obj.get("mortgage_club_name"),
            "proc_fee_code": obj.get("proc_fee_code"),
            "proc_fee": obj.get("proc_fee"),
            "net_proc_fee": obj.get("net_proc_fee"),
            "proc_fee_fixed": obj.get("proc_fee_fixed"),
            "proc_fee_percentage": obj.get("proc_fee_percentage"),
            "proc_fee_min": obj.get("proc_fee_min"),
            "proc_fee_max": obj.get("proc_fee_max"),
            "net_proc_fee_fixed": obj.get("net_proc_fee_fixed"),
            "net_proc_fee_percentage": obj.get("net_proc_fee_percentage"),
            "net_proc_fee_min": obj.get("net_proc_fee_min"),
            "net_proc_fee_max": obj.get("net_proc_fee_max")
        })
        return _obj


