# coding: utf-8

"""
    Acre Platform User API

    # CORS CORS is implemented by all Acre API endpoints and only certain hostnames are allowed for each deployment of the API. If your use case requires calling the Acre User API from a browser, please contact Acre to arrange the appropriate configuration. # API Authentication The primary method of authentication for users of the Acre API is with the use of JSON Web Tokens (JWTs), which are suplemented by an application specific API Key. The API key must be provided through the `X-API-KEY` HTTP header and will be provided by your Acre Customer Success Manager. The JWT must be provided through a cookie with key of `authorization`. The JWT must be generated and signed as per the following section. # Generating JWTs JWT must either be generated by a third-party such as Azure ADB2C that has been configured for the appropriate service and/or user account, or alternatively can be generated locally and signed by an private key for which the public key has been made available to Acre via a JWKS URL. In addition to being signed by your private key, the JWT will also need to contain at a minimum:  * An issuer `iss`, which must be a valid URI previously agreed with Acre.  * A subject `sub`, which must be a unique identifier for the user and/or service account previously agreed with Acre.  * An expiry time `exp` which must not be more than four hours in the future.  * A not before time `nbf` which must be in the past, but not greater than six hours in the past.  The JWT should be signed using RS256.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from acre_api.models.authentication_provider_authentication_mechanism import AuthenticationProviderAuthenticationMechanism
from typing import Optional, Set
from typing_extensions import Self

class PartialDetailsOfTheAuthenticationProviderToBePatchedRequired(BaseModel):
    """
    PartialDetailsOfTheAuthenticationProviderToBePatchedRequired
    """ # noqa: E501
    authentication_name: Optional[StrictStr] = Field(default=None, description="Name of authentication provider. This name must be unique.")
    authentication_mechanism: Optional[AuthenticationProviderAuthenticationMechanism] = AuthenticationProviderAuthenticationMechanism.INVALID
    redirect_url: Optional[StrictStr] = Field(default=None, description="Redirect URL for authenticating users.")
    additional_provider_metadata: Optional[Dict[str, StrictStr]] = Field(default=None, description="Additional configuration for this authentication provider. Metadata can include: jwks_uri: the URI that serves the JWKS keys in JSON format. audience: the audience ID used to validate against \"aud\" claim in the JWT. subject_claim_key: the key for the claim in the JWT that identifies the subject (defaults to \"sub\", AD uses \"oid\").")
    disabled: Optional[StrictBool] = Field(default=None, description="Whether this authentication provider is currently disabled.")
    reset_password_url: Optional[StrictStr] = Field(default=None, description="URL to allow the users to reset their password.")
    __properties: ClassVar[List[str]] = ["authentication_name", "authentication_mechanism", "redirect_url", "additional_provider_metadata", "disabled", "reset_password_url"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PartialDetailsOfTheAuthenticationProviderToBePatchedRequired from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PartialDetailsOfTheAuthenticationProviderToBePatchedRequired from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "authentication_name": obj.get("authentication_name"),
            "authentication_mechanism": obj.get("authentication_mechanism") if obj.get("authentication_mechanism") is not None else AuthenticationProviderAuthenticationMechanism.INVALID,
            "redirect_url": obj.get("redirect_url"),
            "additional_provider_metadata": obj.get("additional_provider_metadata"),
            "disabled": obj.get("disabled"),
            "reset_password_url": obj.get("reset_password_url")
        })
        return _obj


